/* (c) Copyright 2003-2021, Real-Time Innovations, Inc. All rights reserved. */
/*
 * @(#)advlog_context_impl.h    generated by: makeheader    Sat Mar  9 09:37:50 2024
 *
 *		built from:	context_impl.ifc
 */

#ifndef advlog_context_impl_h
#define advlog_context_impl_h


#ifdef __cplusplus
extern "C" {
#endif


#define ADVLOGContextScope_beginWithEntries(maxEntryCount__) \
  RTIOsapiActivityContextScope_beginWithEntries(maxEntryCount__)

#define ADVLOGContextScope_beginWithEntriesAndParams( \
        maxEntryCount__, \
        maxParamsCount__) \
  RTIOsapiActivityContextScope_beginWithEntriesAndParams( \
          (maxEntryCount__), \
          (maxParamsCount__))

#ifdef RTI_ENABLE_CPPCHECK_SUPPRESSIONS
  #define ADVLOGContextScope_enterActivity(worker__, contextTemplate__) \
    { \
      struct REDAWorker *workerPtr__ = (worker__); \
      RTIOsapiActivityContextScope_enterActivity( \
              REDAWorker_getActivityContext(workerPtr__), \
              (contextTemplate__)->format); \
    }
#else
  #define ADVLOGContextScope_enterActivity(worker__, contextTemplate__) \
    RTIOsapiActivityContextScope_enterActivity( \
            REDAWorker_getActivityContext(worker__), \
            (contextTemplate__)->format)
#endif /* RTI_ENABLE_CPPCHECK_SUPPRESSIONS */

#ifdef RTI_ENABLE_CPPCHECK_SUPPRESSIONS
  #define ADVLOGContextScope_enterActivityWithParams( \
          worker__, \
          contextTemplate__, \
          ...) \
    { \
      struct REDAWorker *workerPtr__ = (worker__); \
      RTIOsapiActivityContextScope_enterActivityWithParams( \
              REDAWorker_getActivityContext(workerPtr__), \
              (contextTemplate__)->format, \
              __VA_ARGS__); \
    }
#else
  #define ADVLOGContextScope_enterActivityWithParams( \
          worker__, \
          contextTemplate__, \
          ...) \
    RTIOsapiActivityContextScope_enterActivityWithParams( \
            REDAWorker_getActivityContext(worker__), \
            (contextTemplate__)->format, \
            __VA_ARGS__)
#endif /* RTI_ENABLE_CPPCHECK_SUPPRESSIONS */

#ifdef RTI_ENABLE_CPPCHECK_SUPPRESSIONS
  #define ADVLOGContextScope_enterResource(worker__, resource__) \
    { \
      struct REDAWorker *workerPtr__ = (worker__); \
      RTIOsapiActivityContextScope_enterResource( \
              REDAWorker_getActivityContext(workerPtr__), \
              RTI_ADVLOG_CONTEXT_TEMPLATE_RESOURCE_s.format, \
              (resource__)); \
    }
#else
  #define ADVLOGContextScope_enterResource(worker__, resource__) \
    RTIOsapiActivityContextScope_enterResource( \
            REDAWorker_getActivityContext(worker__), \
            RTI_ADVLOG_CONTEXT_TEMPLATE_RESOURCE_s.format, \
            (resource__))
#endif /* RTI_ENABLE_CPPCHECK_SUPPRESSIONS */

#ifdef RTI_ENABLE_CPPCHECK_SUPPRESSIONS
  #define ADVLOGContextScope_enterResourceWithParams( \
          worker__, \
          contextTemplate__, \
          ...) \
    { \
      struct REDAWorker *workerPtr__ = (worker__); \
      RTIOsapiActivityContextScope_enterResourceWithParams( \
              REDAWorker_getActivityContext(workerPtr__), \
              (contextTemplate__)->format, \
              __VA_ARGS__); \
    }
#else
  #define ADVLOGContextScope_enterResourceWithParams( \
          worker__, \
          contextTemplate__, \
          ...) \
    RTIOsapiActivityContextScope_enterResourceWithParams( \
            REDAWorker_getActivityContext(worker__), \
            (contextTemplate__)->format, \
            __VA_ARGS__)
#endif /* RTI_ENABLE_CPPCHECK_SUPPRESSIONS */

#ifdef RTI_ENABLE_CPPCHECK_SUPPRESSIONS
  #define ADVLOGContextScope_enterResourceGuidWithParams( \
          worker__, \
          contextTemplate__, \
          ...) \
    { \
      struct REDAWorker *workerPtr__ = (worker__); \
      RTIOsapiActivityContextScope_enterResourceGuidWithParams( \
              REDAWorker_getActivityContext(workerPtr__), \
              (contextTemplate__)->format, \
              __VA_ARGS__); \
    }
#else
  #define ADVLOGContextScope_enterResourceGuidWithParams( \
          worker__, \
          contextTemplate__, \
          ...) \
    RTIOsapiActivityContextScope_enterResourceGuidWithParams( \
            REDAWorker_getActivityContext(worker__), \
            (contextTemplate__)->format, \
            __VA_ARGS__)
#endif /* RTI_ENABLE_CPPCHECK_SUPPRESSIONS */

#ifdef RTI_ENABLE_CPPCHECK_SUPPRESSIONS
  #define ADVLOGContextScope_end(worker__) \
    { \
      struct REDAWorker *workerPtr__ = (worker__); \
      RTIOsapiActivityContextScope_end( \
              REDAWorker_getActivityContext(workerPtr__)); \
    }

#else
  #define ADVLOGContextScope_end(worker__) \
    RTIOsapiActivityContextScope_end(REDAWorker_getActivityContext(worker__))
#endif /* RTI_ENABLE_CPPCHECK_SUPPRESSIONS */



#ifdef RTI_ENABLE_CPPCHECK_SUPPRESSIONS
  #define ADVLOGContext_enter(worker__, entry__) \
    { \
      struct REDAWorker *workerPtr__ = (worker__); \
      RTIOsapiActivityContext_enter( \
              REDAWorker_getActivityContext(workerPtr__), \
              (entry__)); \
    }
#else
  #define ADVLOGContext_enter(worker__, entry__) \
    RTIOsapiActivityContext_enter( \
            REDAWorker_getActivityContext(worker__), \
            (entry__))
#endif /* RTI_ENABLE_CPPCHECK_SUPPRESSIONS */

#ifdef RTI_ENABLE_CPPCHECK_SUPPRESSIONS
  #define ADVLOGContext_enterPair(worker__, entry1__, entry2__) \
    { \
      struct REDAWorker *workerPtr__ = (worker__); \
      RTIOsapiActivityContext_enterPair( \
              REDAWorker_getActivityContext(workerPtr__), \
              (entry1__), \
              (entry2__)); \
    }
#else
  #define ADVLOGContext_enterPair(worker__, entry1__, entry2__) \
    RTIOsapiActivityContext_enterPair( \
            REDAWorker_getActivityContext(worker__), \
            (entry1__), \
            (entry2__))
#endif /* RTI_ENABLE_CPPCHECK_SUPPRESSIONS */

#ifdef RTI_ENABLE_CPPCHECK_SUPPRESSIONS
  #define ADVLOGContextScope_leave(worker__) \
    { \
      struct REDAWorker *workerPtr__ = (worker__); \
      RTIOsapiActivityContextScope_leave( \
              REDAWorker_getActivityContext(workerPtr__)); \
    }
#else
  #define ADVLOGContextScope_leave(worker__) \
    RTIOsapiActivityContextScope_leave(REDAWorker_getActivityContext(worker__))
#endif /* RTI_ENABLE_CPPCHECK_SUPPRESSIONS */

#ifdef RTI_ENABLE_CPPCHECK_SUPPRESSIONS
  #define ADVLOGContext_leave(worker__) \
    { \
      struct REDAWorker *workerPtr__ = (worker__); \
      RTIOsapiActivityContext_leave( \
              REDAWorker_getActivityContext(workerPtr__)); \
    }
#else
  #define ADVLOGContext_leave(worker__) \
    RTIOsapiActivityContext_leave(REDAWorker_getActivityContext(worker__))
#endif /* RTI_ENABLE_CPPCHECK_SUPPRESSIONS */

#ifdef RTI_ENABLE_CPPCHECK_SUPPRESSIONS
  #define ADVLOGContext_leaveGroup(worker__, groupSize__) \
    { \
      struct REDAWorker *workerPtr__ = (worker__); \
      RTIOsapiActivityContext_leaveGroup( \
              REDAWorker_getActivityContext(workerPtr__), \
              (groupSize__)); \
    }
#else
  #define ADVLOGContext_leaveGroup(worker__, groupSize__) \
    RTIOsapiActivityContext_leaveGroup( \
            REDAWorker_getActivityContext(worker__), \
            (groupSize__))
#endif /* RTI_ENABLE_CPPCHECK_SUPPRESSIONS */



#ifdef __cplusplus
} /* extern "C" */
#endif


#endif /* advlog_context_impl_h */
