/* (c) Copyright 2003-2021, Real-Time Innovations, Inc. All rights reserved. */
/*
 * @(#)dds_c_monitoring.h    generated by: makeheader    Sat Mar  9 09:39:09 2024
 *
 *		built from:	monitoring.ifc
 */

#ifndef dds_c_monitoring_h
#define dds_c_monitoring_h


  #ifndef dds_c_infrastructure_h
    #include "dds_c/dds_c_infrastructure.h"
  #endif
  #ifndef ndds_config_c_h
    #include "ndds/ndds_config_c.h"
  #endif
  #ifndef dds_c_domain_h
    #include "dds_c/dds_c_domain.h"
  #endif
  #ifndef dds_c_infrastructure_h
    #include "dds_c/dds_c_infrastructure.h"
  #endif
#ifdef __cplusplus
    extern "C" {
#endif
/* ----------------------------------------------------------------- */
/* Monitoring Library  1.0                                           */
/* ----------------------------------------------------------------- */

#define DDS_MONITORING_LIBRARY_PROPERTY_NAME		 	"rti.monitor.library"
#define DDS_MONITORING_CREATE_FUNCTION_PROPERTY_NAME 		"rti.monitor.create_function"
#define DDS_MONITORING_CREATE_FUNCTION_PTR_PROPERTY_NAME 	"rti.monitor.create_function_ptr"

/* description topic names */
#define DDS_MONITORING_PARTICIPANT_DESC_TOPIC_NAME "rti/dds/monitoring/domainParticipantDescription"
#define DDS_MONITORING_TOPIC_DESC_TOPIC_NAME "rti/dds/monitoring/topicDescription"
#define DDS_MONITORING_PUBLISHER_DESC_TOPIC_NAME "rti/dds/monitoring/publisherDescription"
#define DDS_MONITORING_SUBSCRIBER_DESC_TOPIC_NAME "rti/dds/monitoring/subscriberDescription"
#define DDS_MONITORING_READER_DESC_TOPIC_NAME "rti/dds/monitoring/dataReaderDescription"
#define DDS_MONITORING_WRITER_DESC_TOPIC_NAME "rti/dds/monitoring/dataWriterDescription"

/* statistics topic names */
#define DDS_MONITORING_PROCESS_STAT_TOPIC_NAME "rti/dds/monitoring/processStatistics"
#define DDS_MONITORING_PARTICIPANT_STAT_TOPIC_NAME "rti/dds/monitoring/domainParticipantEntityStatistics"
#define DDS_MONITORING_READER_STAT_TOPIC_NAME "rti/dds/monitoring/dataReaderEntityStatistics"
#define DDS_MONITORING_WRITER_STAT_TOPIC_NAME "rti/dds/monitoring/dataWriterEntityStatistics"
#define DDS_MONITORING_TOPIC_STAT_TOPIC_NAME "rti/dds/monitoring/topicEntityStatistics"

/* matched statistics topic names */
#define DDS_MONITORING_READER_MATCHED_TOPIC_NAME "rti/dds/monitoring/dataReaderEntityMatchedPublicationStatistics"
#define DDS_MONITORING_WRITER_MATCHED_TOPIC_NAME "rti/dds/monitoring/dataWriterEntityMatchedSubscriptionStatistics"
#define DDS_MONITORING_WRITER_MATCHED_W_LOCATOR_TOPIC_NAME "rti/dds/monitoring/dataWriterEntityMatchedSubscriptionWithLocatorStatistics"

#define DDS_MONITORING_TOPIC_NAMES { \
    DDS_MONITORING_PARTICIPANT_DESC_TOPIC_NAME, \
    DDS_MONITORING_TOPIC_DESC_TOPIC_NAME, \
    DDS_MONITORING_PUBLISHER_DESC_TOPIC_NAME, \
    DDS_MONITORING_SUBSCRIBER_DESC_TOPIC_NAME, \
    DDS_MONITORING_READER_DESC_TOPIC_NAME, \
    DDS_MONITORING_WRITER_DESC_TOPIC_NAME, \
    DDS_MONITORING_PROCESS_STAT_TOPIC_NAME, \
    DDS_MONITORING_PARTICIPANT_STAT_TOPIC_NAME, \
    DDS_MONITORING_READER_STAT_TOPIC_NAME, \
    DDS_MONITORING_WRITER_STAT_TOPIC_NAME, \
    DDS_MONITORING_TOPIC_STAT_TOPIC_NAME, \
    DDS_MONITORING_READER_MATCHED_TOPIC_NAME, \
    DDS_MONITORING_WRITER_MATCHED_TOPIC_NAME, \
    DDS_MONITORING_WRITER_MATCHED_W_LOCATOR_TOPIC_NAME \
}


struct RTIMonitorParticipantObject;

typedef enum {
	RTI_MONITOR_RETCODE_VERSION_MISMATCH,
	RTI_MONITOR_RETCODE_ERROR,
	RTI_MONITOR_RETCODE_SUCCESS
} RTIMonitorReturnCode;

typedef 
struct RTIMonitorClass *(*RTIMonitor_createFnc)(
	RTIMonitorReturnCode *retcode, /* out */
        DDS_DomainParticipantFactory * factory,
	struct DDS_ProductVersion_t productVersion);

typedef
RTIMonitorReturnCode (*RTIMonitor_deleteFnc)(
	struct RTIMonitorClass *monitoringClass);

typedef
struct RTIMonitorParticipantObject * (*RTIMonitor_domainParticipantAttach)(
	RTIMonitorReturnCode *retcode, /* out */
	struct RTIMonitorClass *monitoringClass,
	DDS_DomainParticipant *participant);

typedef 
RTIMonitorReturnCode (*RTIMonitor_domainParticipantDetach)(
	struct RTIMonitorParticipantObject *monitorParticipantObject);

typedef enum {
	/* Participant */
	PARTICIPANT_ENABLE_AFTER                     = 0x010,
	PARTICIPANT_QOS_CHANGE_AFTER                 = 0x020,
	PARTICIPANT_DELETE_CONTAINED_ENTITIES_BEFORE = 0x041,

	/* Topic */
	TOPIC_CREATE_AFTER                           = 0x100,
	TOPIC_ENABLE_AFTER                           = 0x110,
	TOPIC_QOS_CHANGE_AFTER                       = 0x120,
	TOPIC_DELETE_BEFORE                          = 0x131,

	/* Publisher */
	PUBLISHER_CREATE_AFTER                       = 0x200,
	PUBLISHER_ENABLE_AFTER                       = 0x210,
	PUBLISHER_QOS_CHANGE_AFTER                   = 0x220,
	PUBLISHER_DELETE_BEFORE                      = 0x231,
	PUBLISHER_DELETE_CONTAINED_ENTITIES_BEFORE   = 0x241,

	/* Subscriber */
	SUBSCRIBER_CREATE_AFTER                      = 0x300,
	SUBSCRIBER_ENABLE_AFTER                      = 0x310,
	SUBSCRIBER_QOS_CHANGE_AFTER                  = 0x320,
	SUBSCRIBER_DELETE_BEFORE                     = 0x331,
	SUBSCRIBER_DELETE_CONTAINED_ENTITIES_BEFORE  = 0x341,

	/* Datawriter */
	DATAWRITER_CREATE_AFTER                      = 0x400,
	DATAWRITER_ENABLE_AFTER                      = 0x410,
	DATAWRITER_QOS_CHANGE_AFTER                  = 0x420,
	DATAWRITER_DELETE_BEFORE                     = 0x431,

	/* Datareader */
	DATAREADER_CREATE_AFTER                      = 0x500,
	DATAREADER_ENABLE_AFTER                      = 0x510,
	DATAREADER_QOS_CHANGE_AFTER                  = 0x520,
	DATAREADER_DELETE_BEFORE                     = 0x531,

	/* Matching pairs */
	DATAWRITER_LOCATOR_PAIR_CREATE_AFTER	     = 0x600,
	DATAWRITER_LOCATOR_PAIR_DELETE_AFTER	     = 0x630,

	ENTITY_MATCH_PAIR_CREATE_AFTER		     = 0x700,
	ENTITY_MATCH_PAIR_DELETE_AFTER		     = 0x730
} RTIMonitorEventKind;

typedef 
RTIMonitorReturnCode (*RTIMonitor_eventNotifyFnc)(
    	struct RTIMonitorParticipantObject *monitorParticipantObject,
	RTIMonitorEventKind eventKind,
	DDS_Entity *affectedDDSEntity,
	void *eventInfo);

struct RTIMonitorClass {
        DDS_DomainParticipantFactory * factory;
	RTIMonitor_deleteFnc               deleteFnc;
	RTIMonitor_domainParticipantAttach domainParticipantAttachFnc;
	RTIMonitor_domainParticipantDetach domainParticipantDetachFnc;
	RTIMonitor_eventNotifyFnc          eventNotifyFnc;

	void * userData;
};


struct RTI_MonitoringClass;

extern DDSCDllExport 
struct RTI_MonitoringLoggingVerbositySetting_t *
RTI_MonitoringLoggingVerbositySetting_t_copy(
        struct RTI_MonitoringLoggingVerbositySetting_t *self,
        const struct RTI_MonitoringLoggingVerbositySetting_t *from);

extern DDSCDllExport 
void RTI_MonitoringLoggingVerbositySetting_t_finalize(
        struct RTI_MonitoringLoggingVerbositySetting_t *self);

extern DDSCDllExport 
void RTI_MonitoringLoggingVerbositySetting_t_initialize(
        struct RTI_MonitoringLoggingVerbositySetting_t *self);

extern DDSCDllExport 
DDS_Boolean RTI_MonitoringLoggingVerbositySetting_t_equals(
        const struct RTI_MonitoringLoggingVerbositySetting_t *left,
        const struct RTI_MonitoringLoggingVerbositySetting_t *right);

extern DDSCDllExport 
void RTI_MonitoringLoggingVerbositySetting_t_get_from_logger(
        struct RTI_MonitoringLoggingVerbositySetting_t *self,
        NDDS_Config_Logger *logger);


struct RTI_MonitoringLoggingVerbositySetting_t {
    /*i \dref_MonitoringLoggingVerbositySetting_t_middleware */
    NDDS_Config_SyslogVerbosity middleware;
    /*i \dref_MonitoringLoggingVerbositySetting_t_security_event */
    NDDS_Config_SyslogVerbosity security_event;
    /*i \dref_MonitoringLoggingVerbositySetting_t_service */
    NDDS_Config_SyslogVerbosity service;
    /*i \dref_MonitoringLoggingVerbositySetting_t_user */
    NDDS_Config_SyslogVerbosity user;
};

extern DDSCDllExport 
struct RTI_MonitoringLoggingProperty_t * RTI_MonitoringLoggingProperty_t_copy(
        struct RTI_MonitoringLoggingProperty_t *self,
        const struct RTI_MonitoringLoggingProperty_t *from);

extern DDSCDllExport 
void RTI_MonitoringLoggingProperty_t_finalize(
        struct RTI_MonitoringLoggingProperty_t *self);

extern DDSCDllExport 
void RTI_MonitoringLoggingProperty_t_initialize(
        struct RTI_MonitoringLoggingProperty_t *self);

extern DDSCDllExport 
DDS_Boolean RTI_MonitoringLoggingProperty_t_equals(
        const struct RTI_MonitoringLoggingProperty_t *left,
        const struct RTI_MonitoringLoggingProperty_t *right);


struct RTI_MonitoringLoggingProperty_t {
    /*i \dref_MonitoringLoggingProperty_t_forwarding_level */
    struct RTI_MonitoringLoggingVerbositySetting_t forwarding_level;
    /*i \dref_MonitoringLoggingProperty_t_thread_setting */
    struct DDS_ThreadSettings_t thread_setting;
    /*i \dref_MonitoringLoggingProperty_t_writer_qos */
    struct DDS_DataWriterQos *writer_qos;
    /*i \dref_MonitoringLoggingProperty_t_publication_period */
    struct DDS_Duration_t publication_period;
    /*i \dref_MonitoringLoggingProperty_t_concurrency_level */
    DDS_UnsignedLong concurrency_level;
    /*i \dref_MonitoringLoggingProperty_t_initial_memory_size */
    DDS_Long initial_memory_size;
    /*i \dref_MonitoringLoggingProperty_t_gc_threshold */
    DDS_UnsignedLong gc_threshold;
    /*i \dref_MonitoringLoggingProperty_t_max_logs_per_update */
    DDS_Long max_logs_per_update;
    /*i \dref_MonitoringLoggingProperty_t_max_historical_logs */
    DDS_Long max_historical_logs;

    DDSCPP_VARIABLE_LENGTH_VALUE_TYPE_SUPPORT(RTI_MonitoringLoggingProperty_t)
};

extern DDSCDllExport 
struct RTI_MonitoringPeriodicProperty_t * RTI_MonitoringPeriodicProperty_t_copy(
        struct RTI_MonitoringPeriodicProperty_t *self,
        const struct RTI_MonitoringPeriodicProperty_t *from);

extern DDSCDllExport 
void RTI_MonitoringPeriodicProperty_t_finalize(
        struct RTI_MonitoringPeriodicProperty_t *self);

extern DDSCDllExport 
void RTI_MonitoringPeriodicProperty_t_initialize(
        struct RTI_MonitoringPeriodicProperty_t *self);

extern DDSCDllExport
DDS_Boolean RTI_MonitoringPeriodicProperty_t_equals(
        const struct RTI_MonitoringPeriodicProperty_t *left,
        const struct RTI_MonitoringPeriodicProperty_t *right);


struct RTI_MonitoringPeriodicProperty_t {
    /*i \dref_MonitoringPeriodicProperty_t_polling_period */
    struct DDS_Duration_t polling_period;
    /*i \dref_MonitoringPeriodicProperty_t_thread_setting */
    struct DDS_ThreadSettings_t thread_setting;
    /*i \dref_MonitoringPeriodicProperty_t_writer_qos */
    struct DDS_DataWriterQos *writer_qos;

    DDSCPP_VARIABLE_LENGTH_VALUE_TYPE_SUPPORT(RTI_MonitoringPeriodicProperty_t)
};

extern DDSCDllExport 
struct RTI_MonitoringEventProperty_t * RTI_MonitoringEventProperty_t_copy(
        struct RTI_MonitoringEventProperty_t *self,
        const struct RTI_MonitoringEventProperty_t *from);

extern DDSCDllExport 
void RTI_MonitoringEventProperty_t_finalize(
        struct RTI_MonitoringEventProperty_t *self);

extern DDSCDllExport 
void RTI_MonitoringEventProperty_t_initialize(
        struct RTI_MonitoringEventProperty_t *self);

extern DDSCDllExport 
DDS_Boolean RTI_MonitoringEventProperty_t_equals(
        const struct RTI_MonitoringEventProperty_t *left,
        const struct RTI_MonitoringEventProperty_t *right);


struct RTI_MonitoringEventProperty_t {
    /*i \dref_MonitoringEventProperty_t_publication_period */
    struct DDS_Duration_t publication_period;
    /*i \dref_MonitoringEventProperty_t_thread_setting */
    struct DDS_ThreadSettings_t thread_setting;
    /*i \dref_MonitoringEventProperty_t_writer_qos */
    struct DDS_DataWriterQos *writer_qos;
    /*i \dref_MonitoringEventProperty_t_concurrency_level */
    DDS_UnsignedLong concurrency_level;
    /*i \dref_MonitoringEventProperty_t_initial_memory_size */
    DDS_Long initial_memory_size;
    /*i \dref_MonitoringEventProperty_t_gc_threshold */
    DDS_UnsignedLong gc_threshold;
    /*i \dref_MonitoringEventProperty_t_snapshot_delay */
    struct DDS_Duration_t snapshot_delay;

    DDSCPP_VARIABLE_LENGTH_VALUE_TYPE_SUPPORT(RTI_MonitoringEventProperty_t)
};

extern DDSCDllExport 
struct RTI_MonitoringCommandDispatcherProperty_t * 
RTI_MonitoringCommandDispatcherProperty_t_copy(
        struct RTI_MonitoringCommandDispatcherProperty_t *self,
        const struct RTI_MonitoringCommandDispatcherProperty_t *from);

extern DDSCDllExport 
void RTI_MonitoringCommandDispatcherProperty_t_finalize(
        struct RTI_MonitoringCommandDispatcherProperty_t *self);

extern DDSCDllExport 
void RTI_MonitoringCommandDispatcherProperty_t_initialize(
        struct RTI_MonitoringCommandDispatcherProperty_t *self);

extern DDSCDllExport
DDS_Boolean RTI_MonitoringCommandDispatcherProperty_t_equals(
        const struct RTI_MonitoringCommandDispatcherProperty_t *left,
        const struct RTI_MonitoringCommandDispatcherProperty_t *right);


struct RTI_MonitoringCommandDispatcherProperty_t {
    /*i \dref_MonitoringCommandDispatcherProperty_t_reply_timeout */
    struct DDS_Duration_t reply_timeout;
    /*i \dref_MonitoringCommandDispatcherProperty_t_lock_timeout */
    struct DDS_Duration_t lock_timeout;
    /*i \dref_MonitoringCommandDispatcherProperty_t_destruction_timeout */
    struct DDS_Duration_t destruction_timeout;
    /*i \dref_MonitoringCommandDispatcherProperty_t_thread_setting */
    struct DDS_ThreadSettings_t thread_setting;

    DDSCPP_VARIABLE_LENGTH_VALUE_TYPE_SUPPORT(
            RTI_MonitoringCommandDispatcherProperty_t)
};

extern DDSCDllExport 
struct RTI_MonitoringProperty_t * RTI_MonitoringProperty_t_copy(
        struct RTI_MonitoringProperty_t *self,
        const struct RTI_MonitoringProperty_t *from);

extern DDSCDllExport 
void RTI_MonitoringProperty_t_finalize(
        struct RTI_MonitoringProperty_t *self);

extern DDSCDllExport 
void RTI_MonitoringProperty_t_initialize(
        struct RTI_MonitoringProperty_t *self);

extern DDSCDllExport
DDS_Boolean RTI_MonitoringProperty_t_equals(
        const struct RTI_MonitoringProperty_t *left,
        const struct RTI_MonitoringProperty_t *right);


struct RTI_MonitoringProperty_t {
    /*i \dref_MonitoringProperty_t_domain_id */
    DDS_DomainId_t domain_id;
    /*i \dref_MonitoringProperty_t_application_name */
    char *application_name;
    /*i \dref_MonitoringProperty_t_participant_qos */
    struct DDS_DomainParticipantQos *participant_qos;
    /*i \dref_MonitoringProperty_t_publisher_qos */
    struct DDS_PublisherQos *publisher_qos;
    /*i \dref_MonitoringProperty_t_logging */
    struct RTI_MonitoringLoggingProperty_t logging;
    /*i \dref_MonitoringProperty_t_periodic */
    struct RTI_MonitoringPeriodicProperty_t periodic;
    /*i \dref_MonitoringProperty_t_event */
    struct RTI_MonitoringEventProperty_t event;
    /*i \dref_MonitoringProperty_t_command_dispatcher */
    struct RTI_MonitoringCommandDispatcherProperty_t command_dispatcher;
    /*i \dref_MonitoringProperty_t_metric_selection_list */
    struct DDS_MonitoringMetricSelectionSeq metric_selection_list;
    /*i \dref_MonitoringProperty_t_collector_initial_peers */
    struct DDS_StringSeq collector_initial_peers;

    DDSCPP_VARIABLE_LENGTH_VALUE_TYPE_SUPPORT(RTI_MonitoringProperty_t)
};


#define RTI_MonitoringLoggingVerbositySetting_t_INITIALIZER \
  { \
    NDDS_CONFIG_SYSLOG_VERBOSITY_WARNING, /* middleware */ \
    NDDS_CONFIG_SYSLOG_VERBOSITY_WARNING, /* security_event */ \
    NDDS_CONFIG_SYSLOG_VERBOSITY_WARNING, /* service */ \
    NDDS_CONFIG_SYSLOG_VERBOSITY_WARNING, /* user */ \
  }

#define RTI_MonitoringLoggingProperty_t_INITIALIZER \
  { \
    RTI_MonitoringLoggingVerbositySetting_t_INITIALIZER, \
    /* logging.forwarding_level */ \
    DDS_THREAD_SETTINGS_DEFAULT,          /* logging.thread_setting */ \
    NULL,                                 /* logging.writer_qos */ \
    { 1, 0 },                             /* logging.publication_period */ \
    5,                                    /* logging.concurrency_level */ \
    10240, /* logging.initial_memory_size (10KB) */ \
    10,    /* logging.gc_threshold */ \
    1024,  /* logging.max_logs_per_update */ \
    128    /* logging.max_historical_logs */ \
  }

#define RTI_MonitoringPeriodicProperty_t_INITIALIZER { \
    { 5, 0 }, /* periodic.polling_period */ \
    DDS_THREAD_SETTINGS_DEFAULT, /* periodic.thread_setting */ \
    NULL /* periodic.writer_qos */ \
}

#define RTI_MonitoringEventProperty_t_INITIALIZER { \
    { 1, 0 }, /* event.publication_period */ \
    DDS_THREAD_SETTINGS_DEFAULT, /* event.thread_setting */ \
    NULL, /* event.writer_qos */ \
    5, /* event.concurrency_level */ \
    10240, /* event.initial_memory_size */ \
    10, /* event.gc_threshold */ \
    {3, 0} /* event.snapshot_delay */ \
}

#define RTI_MonitoringCommandDispatcherProperty_t_INITIALIZER { \
    { 10, 0 }, /* command_dispatcher.reply_timeout */ \
    { 2, 0 }, /* command_dispatcher.lock_timeout */ \
    { 15, 0 }, /* command_dispatcher.destruction_timeout */ \
    DDS_THREAD_SETTINGS_DEFAULT /* command_dispatcher.thread_setting */ \
}

/*ci \dref_MonitoringProperty_t_INITIALIZER
 */
#define RTI_MonitoringProperty_t_INITIALIZER \
  { \
    2,                                            /* domain_id */ \
    NULL,                                         /* application_name */ \
    NULL,                                         /* participant_qos */ \
    NULL,                                         /* publisher_qos */ \
    RTI_MonitoringLoggingProperty_t_INITIALIZER,  /* logging */ \
    RTI_MonitoringPeriodicProperty_t_INITIALIZER, /* periodic */ \
    RTI_MonitoringEventProperty_t_INITIALIZER,    /* event */ \
    RTI_MonitoringCommandDispatcherProperty_t_INITIALIZER, /* command dispatcher */ \
    DDS_SEQUENCE_INITIALIZER, /* metrics */ \
    DDS_SEQUENCE_INITIALIZER /* collector_initial_peers */ \
  }

 extern DDSCDllVariable
const struct RTI_MonitoringProperty_t RTI_MonitoringProperty_t_DEFAULT;

typedef DDS_Boolean (*RTI_Monitoring_GetMetricGroupFunction)(
        void **application_metric_group,
        const void *user_resource,
        DDS_UnsignedLong metric_group_index);

typedef DDS_Boolean (*RTI_Monitoring_ReturnMetricGroupFunction)(
        void **application_metric_group,
        DDS_UnsignedLong metric_group_index);

typedef DDS_Boolean (*RTI_Monitoring_CollectResourcesFunction)(
        struct RTI_MonitoringClass *self);

struct RTI_MonitoringResourceForwarder {
    /*i \dref_MonitoringResourceForwarder_get_metric_group_function */
    RTI_Monitoring_GetMetricGroupFunction get_metric_group_function;
    /*i \dref_MonitoringResourceForwarder_return_metric_group_function */
    RTI_Monitoring_ReturnMetricGroupFunction return_metric_group_function;
};


/*i
 * \dref_MonitoringResourceForwarder_t_INITIALIZER
 */
#define RTI_MonitoringResourceForwarder_INITIALIZER \
  { \
    NULL, /* get_metric_group_function */ \
    NULL  /* return_metric_group_function */ \
  }

struct RTI_MonitoringResource;

struct RTI_MonitoringResourceHandle {
    struct RTI_MonitoringResource *resource;
    DDS_UnsignedLong concurrencyIndex;
    DDS_UnsignedLongLong libraryEpoch;
};

 extern DDSCDllVariable const struct RTI_MonitoringResourceHandle
        RTI_MONITORING_RESOURCE_HANDLE_NIL;

extern DDSCDllExport DDS_Boolean RTI_MonitoringResourceHandle_is_nil(
        const struct RTI_MonitoringResourceHandle self);

extern DDSCDllExport struct RTI_MonitoringResourceHandle
RTI_Monitoring_assert_resource(
        const struct DDS_GUID_t *user_resource_guid,
        DDS_UnsignedLong class_id,
        const char *resource_name,
        void *user_resource,
        struct RTI_MonitoringResourceHandle parent_resource,
        const struct RTI_MonitoringResourceForwarder *forwarder,
        DDS_Boolean is_monitoring_locked);

extern DDSCDllExport
void RTI_Monitoring_delete_resource(
        struct RTI_MonitoringResourceHandle resource,
        DDS_Boolean is_monitoring_locked);

extern DDSCDllExport
void RTI_Monitoring_delete_resource_children(
        struct RTI_MonitoringResourceHandle resource,
        DDS_Boolean is_monitoring_locked);

extern DDSCDllExport
RTIBool RTI_Monitoring_is_enabled(void);

extern DDSCDllExport
DDS_Boolean RTI_Monitoring_enable(DDS_DomainParticipantFactory *factory);

extern DDSCDllExport DDS_Boolean RTI_Monitoring_enable_with_property(
        DDS_DomainParticipantFactory *factory,
        const struct RTI_MonitoringProperty_t *property,
        RTI_Monitoring_CollectResourcesFunction collect_resources_function);

extern DDSCDllExport
void RTI_Monitoring_disable(void);


typedef enum RTI_MonitoringLockResult {
    /*i \dref_RTI_MonitoringLockResult_RTI_MONITORING_LOCK_RESULT_OK */
    RTI_MONITORING_LOCK_RESULT_OK = 0,
    /*i \dref_RTI_MonitoringLockResult_RTI_MONITORING_LOCK_RESULT_ERROR */
    RTI_MONITORING_LOCK_RESULT_ERROR,
    /*i \dref_RTI_MonitoringLockResult_RTI_MONITORING_LOCK_RESULT_NOT_ENABLED */
    RTI_MONITORING_LOCK_RESULT_NOT_ENABLED,
    /*i \dref_RTI_MonitoringLockResult_RTI_MONITORING_LOCK_RESULT_TIMEOUT */
    RTI_MONITORING_LOCK_RESULT_TIMEOUT
} RTI_MonitoringLockResult;

extern DDSCDllExport
RTI_MonitoringLockResult RTI_Monitoring_lock(void);

extern DDSCDllExport
RTI_MonitoringLockResult RTI_Monitoring_unlock(void);

extern DDSCDllExport DDS_Boolean RTI_Monitoring_push_event_metric(
        void *application_metric_group,
        const struct RTI_MonitoringResourceHandle resource,
        DDS_UnsignedLong metric_group_index);

extern DDSCDllExport DDS_Boolean RTI_Monitoring_pause_resource_metrics(
        struct RTI_MonitoringResourceHandle resource,
        DDS_Boolean is_monitoring_locked);

extern DDSCDllExport DDS_Boolean RTI_Monitoring_pause_resource_children_metrics(
        struct RTI_MonitoringResourceHandle resource);

extern DDSCDllExport DDS_Boolean RTI_Monitoring_resume_resource_metrics(
        struct RTI_MonitoringResourceHandle resource);

extern DDSCDllVariable const char * const RTI_MONITORING_PERIODIC_TOPIC_NAME;

extern DDSCDllVariable const char * const RTI_MONITORING_EVENT_TOPIC_NAME;

extern DDSCDllVariable const char * const RTI_MONITORING_LOGGING_TOPIC_NAME;


#ifdef __cplusplus
    }	/* extern "C" */
#endif

#ifndef dds_c_monitoring_impl_h
  #include "dds_c/dds_c_monitoring_impl.h"
#endif


#endif /* dds_c_monitoring_h */
