/* (c) Copyright 2003-2021, Real-Time Innovations, Inc. All rights reserved. */
/*
 * @(#)disc_simple_discovery_plugin.h    generated by: makeheader    Sat Mar  9 09:39:00 2024
 *
 *		built from:	simple_discovery_plugin.ifc
 */

#ifndef disc_simple_discovery_plugin_h
#define disc_simple_discovery_plugin_h


 #ifndef rti_makeheader_h
    #include "log/log_makeheader.h"
 #endif
 #ifndef osapi_ntptime_h
    #include "osapi/osapi_ntptime.h"
 #endif
 #ifndef mig_rtps_h
    #include "mig/mig_rtps.h"
 #endif
 #ifndef pres_common_h
    #include "pres/pres_common.h"
 #endif
 #ifndef pres_typePlugin_h
    #include "pres/pres_typePlugin.h"
 #endif
 #ifndef pres_participant_h
    #include "pres/pres_participant.h"
 #endif
 #ifndef pres_psService_h
    #include "pres/pres_psService.h"
 #endif
#ifndef pres_participantChannel_h
  #include "pres/pres_participantChannel.h"
#endif
#ifndef disc_pluggable_h
  #include "disc/disc_pluggable.h"
#endif
#ifndef disc_builtin_h
  #include "disc/disc_builtin.h"
#endif
#ifndef netio_dnsTracker_h
  #include "netio/netio_dnsTracker.h"
#endif


#ifdef __cplusplus
    extern "C" {
#endif


/* Full Data(p) */
#define DISC_SIMPLE_DISCOVERY_PLUGIN_PARTICIPANT_PARAMETER           "DISCParticipantParameter"
/* Announcement */
#define DISC_SIMPLE_DISCOVERY_PLUGIN_PARTICIPANT_BOOTSTRAP_PARAMETER "DISCParticipantBootstrapParameter"
#define DISC_SIMPLE_DISCOVERY_PLUGIN2_SHORTNAME_BOOTSTRAP            "bootstrap"
/* Config */
#define DISC_SIMPLE_DISCOVERY_PLUGIN2_PARTICIPANT_CONFIG_PARAMETER   "DISCParticipantConfigurationParameter"
#define DISC_SIMPLE_DISCOVERY_PLUGIN2_SHORTNAME_CONFIG                "config"
#define DISC_SIMPLE_DISCOVERY_PLUGIN_TYPE_PARTICIPANT_PARAMETER      "DISCParticipantParameter"

#define DISC_SIMPLE_DISCOVERY_PLUGIN_PARTICIPANT_STATE_PARAMETER     "DISCParticipantStateParameter"

#define DISC_SIMPLE_DISCOVERY_PLUGIN_PUBLICATION_PARAMETER           "DISCPublicationParameter"
#define DISC_SIMPLE_DISCOVERY_PLUGIN_SUBSCRIPTION_PARAMETER          "DISCSubscriptionParameter"


#define DISC_SIMPLE_DISCOVERY_PLUGIN_PARTITION_MAXIMUM_NAME_COUNT_LIMIT                            (64)
#define DISC_SIMPLE_DISCOVERY_PLUGIN_PARTITION_MAXIMUM_NAME_COUNT_DEFAULT                          (0)
#define DISC_SIMPLE_DISCOVERY_PLUGIN_TYPE_CODE_MAXIMUM_SERIALIZED_LENGTH_DEFAULT                   (0)
#define DISC_SIMPLE_DISCOVERY_PLUGIN_TYPE_OBJECT_MAXIMUM_SERIALIZED_LENGTH_DEFAULT                 (0)
#define DISC_SIMPLE_DISCOVERY_PLUGIN_SERIALIZED_TYPE_OBJECT_DYNAMIC_ALLOCATION_THRESHOLD_DEFAULT   (0)
#define DISC_SIMPLE_DISCOVERY_PLUGIN_TYPE_OBJECT_MAXIMUM_DESERIALIZED_LENGTH_DEFAULT               (0)
#define DISC_SIMPLE_DISCOVERY_PLUGIN_DESERIALIZED_TYPE_OBJECT_DYNAMIC_ALLOCATION_THRESHOLD_DEFAULT (0)
#define DISC_SIMPLE_DISCOVERY_PLUGIN_TRANSPORT_INFO_LIST_MAX_LENGTH_DEFAULT                        (12)


struct DISCDiscoveryPluginProperty {
    MIGRtpsHostId hostId;
    MIGRtpsAppId appId;
    MIGRtpsInstanceId instanceId;

    /*i Class-id for the compression used for lb PIDs. */
    RTIOsapiCompressionPluginClassId lbSerializationClassID;

    int participantUserDataMaximumLength;
    int topicDataMaximumLength;
    int writerGroupDataMaximumLength;
    int writerUserDataMaximumLength;
    int readerGroupDataMaximumLength;
    int readerUserDataMaximumLength;
    int partitionMaximumNameCount;
    int partitionMaximumCumulativeLength;
    int typeCodeMaximumSerializedLength;
    int typeObjectMaximumSerializedLength;
    int serializedTypeObjectDynamicAllocationThreshold;
    int typeObjectMaximumDeserializedLength;
    int deserializedTypeObjectDynamicAllocationThreshold;
    /*i Max size in bytes a serialized type object can have to not trigger the
     *  low bandwidh (compressed) serialization. If this limit is exceeded, we
     *  will serialize a compressed version of the serialized type object.
     */
    int typeObjectLbSerializationThreshold;
    int contentFilterPropertyMaxLength;
    int locatorFilterSeqMaxLength;
    int locatorFilterExpressionMaxLength;
    RTIBool enableRtpsDiscoveryOptimization;
};

struct DISCSimpleParticipantDiscoveryBasePluginPDFListener {
    struct DISCParticipantDiscoveryListener parent;

    struct DISCSimpleParticipantDiscoveryBasePlugin **_plugin;
};

struct DISCSimpleParticipantDiscoveryBasePluginProperty {
    struct DISCDiscoveryPluginProperty parent;

    char *multicast_receive_addresses;
    /*
     * This is the participant_liveliness_assert_period of the participant.
     * With SPDP2 this configures the rate that DATA(M)s are sent out to
     * matched participants. With SPDP this configures the rate that DATA(P)s
     * are sent out to potential peers.
     */
    RTINtpTime participantLivelinessAssertPeriod;
    /*
     * This is the participant_liveliness_lease_duration of the participant,
     * or the time that other participants may consider this participant
     * inactive if it has not refreshed its liveliness.
     */
    RTINtpTime expirationTime;
    RTINtpTime dnsTrackerPeriod;
    struct PRESParticipantAnnouncementChannelProperty announcementProperty;
    int participantPropertyListMaximumLength;
    int participantPropertyStringMaximumLength;
    int transportInfoListMaxLength;
    RTIBool broadcastParticipantAnnouncementOnDiscovery;
    PRESCdrPaddingKind cdrPaddingKind;

    /* Used to configure all builtin participant discovery writers */
    struct PRESPsWriterProperty writerProperty;
    /* Used to configure all builtin participant discovery readers */
    struct PRESPsReaderProperty readerProperty;
    /*
     * The transport priority used for readers and writers in the announcement
     * and config channels
     */
    struct PRESTransportPriorityQosPolicy transportPriority;
    /*
     * The transport priority used for readers and writers in the announcement
     * and config channels
     */
    struct RTINetioAliasList transportAliasList;

    /* Whether this is the base for spdp or spdp2 */
    RTIBool isSpdp;
};


#define DISC_SIMPLE_PARTICIPANT_DISCOVERY_BASE_PLUGIN_EXPIRATION_TIME_SEC_DEFAULT \
  180
#define DISC_SIMPLE_PARTICIPANT_DISCOVERY_BASE_PLUGIN_EXPIRATION_TIME_FRAC_DEFAULT \
  0

#define DISC_SIMPLE_PARTICIPANT_DISCOVERY_BASE_PLUGIN_EXPIRATION_TIME_DEFAULT \
  { \
    DISC_SIMPLE_PARTICIPANT_DISCOVERY_BASE_PLUGIN_EXPIRATION_TIME_SEC_DEFAULT, \
            DISC_SIMPLE_PARTICIPANT_DISCOVERY_BASE_PLUGIN_EXPIRATION_TIME_FRAC_DEFAULT \
  }

#define DISC_SIMPLE_PARTICIPANT_DISCOVERY_BASE_PLUGIN_PROPERTY_DEFAULT \
  { \
    DISC_DISCOVERY_PLUGIN_PROPERTY_DEFAULT, /* parent */ \
    NULL,                                   /* multicast_receive_addresses */ \
    PRES_PARTICIPANT_CHANNEL_PARTICIPANT_LIVELINESS_ASSERT_PERIOD_DEFAULT, \
    /* participantLivelinessAssertPeriod */ \
    DISC_SIMPLE_PARTICIPANT_DISCOVERY_BASE_PLUGIN_EXPIRATION_TIME_DEFAULT, \
    /* expirationTime */ \
    RTI_NTP_TIME_MAX, /* dnsTrackerPeriod */ \
    PRES_PARTICIPANT_ANNOUNCEMENT_CHANNEL_PROPERTY_DEFAULT, \
    /* announcementProperty */ \
    PRES_PARTICIPANT_PROPERTY_LIST_MAXIMUM, \
    /* maximum participant property list length */ \
    PRES_PARTICIPANT_PROPERTY_STRING_MAXIMUM, \
    /* maximum participant property list length */ \
    DISC_SIMPLE_DISCOVERY_PLUGIN_TRANSPORT_INFO_LIST_MAX_LENGTH_DEFAULT, \
    /* transportInfoListMaxLength */ \
    RTI_FALSE, /* broadcastParticipantAnnouncementOnDiscovery */ \
    PRES_NOT_SET_CDR_PADDING, /* zeroOnAlign */ \
    PRES_PS_WRITER_PROPERTY_DEFAULT, /* writerProperty */ \
    PRES_PS_READER_PROPERTY_DEFAULT, /* readerProperty */ \
    { NDDS_TRANSPORT_PRIORITY_DEFAULT }, /* transportPriority*/ \
    RTI_NETIO_ALIAS_LIST_DEFAULT,        /* transportAliasList */ \
    RTI_FALSE                            /* isSpdp */ \
  }

extern DISCDllExport void
DISCSimpleParticipantDiscoveryBasePluginProperty_initialize(
        struct DISCSimpleParticipantDiscoveryBasePluginProperty *property);


#define DISCSimpleParticipantDiscoveryPlugin_asBasePlugin(plugin__) \
  *((struct DISCSimpleParticipantDiscoveryBasePlugin **) (plugin__))


#define DISC_DISCOVERY_PLUGIN_PROPERTY_DEFAULT \
  { \
    MIG_RTPS_HOST_ID_UNKNOWN,            /* hostId */ \
    MIG_RTPS_APP_ID_UNKNOWN,             /* appId */ \
    MIG_RTPS_INSTANCE_ID_UNKNOWN,        /* instanceId */ \
    RTI_OSAPI_COMPRESSION_CLASS_ID_AUTO, /* compressionId */ \
    PRES_PARTICIPANT_USER_DATA_MAXIMUM, /* participantUserDataMaximumLength */ \
    PRES_PARTICIPANT_TOPIC_DATA_MAXIMUM, /* topicDataMaximumLength */ \
    PRES_PS_GROUP_DATA_MAXIMUM,          /* writerGroupDataMaximumLength */ \
    PRES_PS_USER_DATA_MAXIMUM,           /* writerUserDataMaximumLength */ \
    PRES_PS_GROUP_DATA_MAXIMUM,          /* readerrGroupDataMaximumLength */ \
    PRES_PS_USER_DATA_MAXIMUM,           /* readerUserDataMaximumLength */ \
    DISC_SIMPLE_DISCOVERY_PLUGIN_PARTITION_MAXIMUM_NAME_COUNT_DEFAULT, \
            /*partitionMaximumNameCount*/ \
    PRES_PS_PARTITION_MAXIMUM_CUMULATIVE_LENGTH_DEFAULT, \
            /*partitionMaximumCumulativeLength*/ \
    DISC_SIMPLE_DISCOVERY_PLUGIN_TYPE_CODE_MAXIMUM_SERIALIZED_LENGTH_DEFAULT, \
            /* typeCodeMaximumSerializedLength */ \
    DISC_SIMPLE_DISCOVERY_PLUGIN_TYPE_OBJECT_MAXIMUM_SERIALIZED_LENGTH_DEFAULT, \
            /* typeObjectMaximumSerializedLength */ \
    DISC_SIMPLE_DISCOVERY_PLUGIN_SERIALIZED_TYPE_OBJECT_DYNAMIC_ALLOCATION_THRESHOLD_DEFAULT, \
            /* serializedTypeObjectDynamicAllocationThreshold */ \
    DISC_SIMPLE_DISCOVERY_PLUGIN_TYPE_OBJECT_MAXIMUM_DESERIALIZED_LENGTH_DEFAULT, \
            /* typeObjectMaximumDeserializedLength */ \
    DISC_SIMPLE_DISCOVERY_PLUGIN_DESERIALIZED_TYPE_OBJECT_DYNAMIC_ALLOCATION_THRESHOLD_DEFAULT, \
            /* deserializedTypeObjectDynamicAllocationThreshold */ \
    PRES_PS_ENDPOINT_DISCOVERY_TYPE_OBJECT_LB_SERIALIZATION_THRESHOLD_DEFAULT, \
            /* typeObjectLbSerializationThreshold */ \
    PRES_CONTENT_FILTER_PROPERTY_LEN_MAX, \
            /* maximum length for content filter property */ \
    PRES_LOCATOR_FILTER_DEFAULT_SEQ_LEN_MAX, \
    PRES_LOCATOR_FILTER_DEFAULT_EXPRESSION_LEN_MAX, \
    PRES_DISCOVERY_ENABLE_RTPS_DISCOVERY_OPTIMIZATION_DEFAULT /* enableRtpsDiscoveryOptimization */ \
  }


struct DISCSimpleParticipantDiscoveryPluginProperty {
    struct DISCSimpleParticipantDiscoveryBasePluginProperty baseProperty;
    /* This is used to determine if we create EDS endpoints */
    RTIBool createEdsEndpoints;
    /* This means we are a PA client only, this is part of EDS */
    RTIBool paClientOnly;
    /* This is part of EDS */
    struct PRESPsSrReaderProperty participantProxyReaderProperty;
    /* This is part of EDS */
    struct PRESPsSrWriterProperty participantStateWriterProperty;
};


#define DISC_PLUGIN_INFO_PARAMETER_MAX_LENGTH       0

extern DISCDllExport void
DISCSimpleParticipantDiscoveryPluginProperty_initialize(
        struct DISCSimpleParticipantDiscoveryPluginProperty *property);


#define DISC_SIMPLE_PARTICIPANT_DISCOVERY_PLUGIN_INFO {     \
MIG_RTPS_VENDOR_ID_RTI,                                     \
DISC_SIMPLE_DISCOVERY_PLUGIN_CLASS_ID,                      \
MIG_RTPS_PROTOCOL_VERSION,                                  \
}

struct DISCSimpleParticipantDiscoveryPlugin2Property {
    struct DISCSimpleParticipantDiscoveryBasePluginProperty baseProperty;
    struct PRESPsSrWriterProperty configWriterProperty;
    struct PRESPsSrReaderProperty configReaderProperty;
};

extern DISCDllExport void
DISCSimpleParticipantDiscoveryPlugin2Property_initialize(
        struct DISCSimpleParticipantDiscoveryPlugin2Property *property);


struct DISCSimpleEndpointDiscoveryPluginProperty {
    struct DISCDiscoveryPluginProperty parent;

    RTIBool relyOnSpdpOnly;

    struct PRESPsSrReaderProperty publicationDetectorProperty;
    struct PRESPsSrReaderProperty subscriptionDetectorProperty;

    struct PRESPsSrWriterProperty publicationAnnouncerProperty;
    struct PRESPsSrWriterProperty subscriptionAnnouncerProperty;

    struct PRESPsWriterGroupProperty announcerGroupProperty;

    /*i
     * The maximum number of name,value pairs in the 
     * writer property list
     */
    int writerPropertyListMaximumLength;

    /*i The total number of bytes, excluding NULL termination,
     * in all the name,value pairs 
     */
    int writerPropertyStringMaximumLength;

    /*i 
     * The maximum number of name,value pairs in the 
     * reader property list
     */
    int readerPropertyListMaximumLength;

    /*i The total number of bytes, excluding NULL termination,
     * in all the name,value pairs 
     */
    int readerPropertyStringMaximumLength;

    /*i
     * The maximum number of name,value pairs in the 
     * writer data tag list
     */
    int writerDataTagListMaximumLength;

    /*i The total number of bytes, excluding NULL termination,
     * in all the name,value pairs 
     */
    int writerDataTagStringMaximumLength;

    /*i 
     * The maximum number of name,value pairs in the 
     * reader data tag list
     */
    int readerDataTagListMaximumLength;

    /*i The total number of bytes, excluding NULL termination,
     * in all the name,value pairs 
     */
    int readerDataTagStringMaximumLength;

    PRESCdrPaddingKind cdrPaddingKind;
};


#define DISC_SIMPLE_ENDPOINT_DISCOVERY_PLUGIN_PROPERTY_DEFAULT {            \
DISC_DISCOVERY_PLUGIN_PROPERTY_DEFAULT,                                     \
RTI_FALSE,                                                                  \
PRES_PS_SR_READER_PROPERTY_DEFAULT, /* publicationDetectorProperty */       \
PRES_PS_SR_READER_PROPERTY_DEFAULT, /* subscriptionDetectorProperty */      \
PRES_PS_SR_WRITER_PROPERTY_DEFAULT, /* publicationAnnouncerProperty */      \
PRES_PS_SR_WRITER_PROPERTY_DEFAULT, /* subscriptionAnnouncerProperty */     \
PRES_PS_WRITER_GROUP_PROPERTY_DEFAULT, /* announcerGroupProperty */         \
PRES_PS_PROPERTY_LIST_MAXIMUM,      /* writerPropertyListMaximumLength */   \
PRES_PS_PROPERTY_STRING_MAXIMUM,    /* writerPropertyStringMaximumLength */ \
PRES_PS_PROPERTY_LIST_MAXIMUM,      /* readerPropertyListMaximumLength */   \
PRES_PS_PROPERTY_STRING_MAXIMUM,    /* readerPropertyStringMaximumLength */ \
PRES_PS_DATA_TAG_LIST_MAXIMUM,      /* writerDataTagListMaximumLength */   \
PRES_PS_DATA_TAG_STRING_MAXIMUM,    /* writerDataTagStringMaximumLength */ \
PRES_PS_DATA_TAG_LIST_MAXIMUM,      /* readerDataTagListMaximumLength */   \
PRES_PS_DATA_TAG_STRING_MAXIMUM,    /* readerDataTagStringMaximumLength */ \
PRES_NOT_SET_CDR_PADDING            /* cdrPaddingKind */                    \
}

extern DISCDllExport
const struct DISCSimpleParticipantDiscoveryBasePluginProperty *
DISCSimpleParticipantDiscoveryBasePlugin_getProperty(
        struct DISCSimpleParticipantDiscoveryBasePlugin *me);

extern DISCDllExport RTIBool
DISCSimpleParticipantDiscoveryBasePlugin_assertInitialDestinations(
        struct DISCSimpleParticipantDiscoveryBasePlugin *me,
        struct RTINetioLocator *destinationList,
        int destinationCount,
        struct REDAWorker *worker);

extern DISCDllExport
RTIBool
DISCSimpleParticipantDiscoveryBasePlugin_assertDomainBroadcastDestination(
        struct DISCSimpleParticipantDiscoveryBasePlugin *me,
        struct RTINetioLocator *destination,
        struct REDAWorker *worker);

extern DISCDllExport
RTIBool DISCSimpleParticipantDiscoveryBasePlugin_removeDestinations(
        struct DISCSimpleParticipantDiscoveryBasePlugin *me,
        struct RTINetioLocator *destinationList,
        int destinationCount,
        struct REDAWorker *worker);

extern DISCDllExport
RTIBool DISCSimpleParticipantDiscoveryBasePlugin_getDnsTrackerPeriod(
        const struct DISCSimpleParticipantDiscoveryBasePlugin *self,
        RTINtpTime *period,
        struct REDAWorker *worker);

extern DISCDllExport
RTIBool DISCSimpleParticipantDiscoveryBasePlugin_setDnsTrackerPeriod(
        struct DISCSimpleParticipantDiscoveryBasePlugin *self,
        const RTINtpTime *newPeriod,
        struct REDAWorker *worker);

extern DISCDllExport
RTI_INT32
DISCSimpleParticipantDiscoveryBasePlugin_getRemainingParticipantWriterResendCount(
        struct DISCSimpleParticipantDiscoveryBasePlugin *me,
        struct REDAWorker *worker);

extern DISCDllExport RTI_INT32
DISCSimpleParticipantDiscoveryBasePlugin_getAnnouncementChannelDestinationCount(
        struct DISCSimpleParticipantDiscoveryBasePlugin *me,
        struct REDAWorker *worker);

extern DISCDllExport
RTIBool DISCSimpleParticipantDiscoveryBasePlugin_setAnnouncementReaderListener(
        struct DISCSimpleParticipantDiscoveryBasePlugin *me,
        int *failReason,
        MIGRtpsObjectId readerObjectId,
        const struct PRESParticipantChannelReaderListener *listener,
        struct REDAWorker *worker);

extern DISCDllExport
RTIBool DISCSimpleParticipantDiscoveryBasePlugin_getAnnouncementReaderListener(
        struct DISCSimpleParticipantDiscoveryBasePlugin *me,
        struct PRESParticipantChannelReaderListener *listener,
        MIGRtpsObjectId readerObjectId);

extern DISCDllExport
struct PRESPsReader *
DISCSimpleParticipantDiscoveryBasePlugin_getParticipantAnnouncementReader(
        const struct DISCSimpleParticipantDiscoveryBasePlugin *me);

extern DISCDllExport RTI_INT32
DISCSimpleParticipantDiscoveryBasePlugin_getParticipantAnnouncementChannelDestinationsCount(
        struct DISCSimpleParticipantDiscoveryBasePlugin *me,
        RTIBool getEnabledDestinationsOnly,
        struct REDAWorker *worker);

extern DISCDllExport
struct DISCSimpleParticipantDiscoveryPlugin *
DISCSimpleParticipantDiscoveryPlugin_new(
        struct DISCSimpleParticipantDiscoveryBasePlugin *basePlugin,
        struct PRESParticipant *participant,
        struct DISCPluginManager *pluginManager,
        const struct RTINetioLocator *peer_destinations,
        int peer_destination_count,
        struct REDAExclusiveArea *readerGroupEA,
        struct REDAExclusiveArea *writerGroupEA,
        const struct DISCSimpleParticipantDiscoveryPluginProperty *property,
        struct REDAWorker *worker);

extern DISCDllExport
RTIBool DISCSimpleParticipantDiscoveryBasePlugin_shutdown(
        struct DISCSimpleParticipantDiscoveryBasePlugin *me,
        struct REDAWorker *worker);

extern DISCDllExport 
void DISCSimpleParticipantDiscoveryPlugin_finalizePlugins(void);

extern DISCDllExport
void DISCSimpleParticipantDiscoveryPlugin_delete(
        struct DISCSimpleParticipantDiscoveryPlugin *me);

extern DISCDllExport
struct DISCSimpleParticipantDiscoveryPlugin2 *
DISCSimpleParticipantDiscoveryPlugin2_new(
        struct DISCSimpleParticipantDiscoveryBasePlugin *basePlugin,
        struct PRESParticipant *participant,
        struct DISCPluginManager *pluginManager,
        const struct RTINetioLocator *peer_destinations,
        int peer_destination_count,
        struct REDAExclusiveArea *readerGroupEA,
        struct REDAExclusiveArea *writerGroupEA,
        const struct DISCSimpleParticipantDiscoveryPlugin2Property *property,
        struct REDAWorker *worker);

extern DISCDllExport
void DISCSimpleParticipantDiscoveryPlugin2_delete(
        struct DISCSimpleParticipantDiscoveryPlugin2 *me);

extern DISCDllExport
RTIBool DISCSimpleParticipantDiscoveryPlugin2_setConfigReaderListener(
        struct DISCSimpleParticipantDiscoveryPlugin2 *me,
        int *failReason,
        MIGRtpsObjectId readerObjectId,
        const struct PRESParticipantChannelReaderListener *listener,
        struct REDAWorker *worker);

extern DISCDllExport
RTIBool DISCSimpleParticipantDiscoveryPlugin2_getConfigReaderListener(
        struct DISCSimpleParticipantDiscoveryPlugin2 *me,
        struct PRESParticipantChannelReaderListener *outListener,
        MIGRtpsObjectId readerObjectId);

extern DISCDllExport RTIBool
DISCSimpleParticipantDiscoveryPlugin2_assertRTPSPeer(
        struct DISCSimpleParticipantDiscoveryPlugin2 *me,
        const struct RTINetioLocator *destinationList,
        int destinationCount,
        struct REDAWorker *worker);

extern DISCDllExport
struct DISCSimpleEndpointDiscoveryPlugin *
DISCSimpleEndpointDiscoveryPlugin_new(
    struct PRESParticipant *participant,
    struct REDAExclusiveArea *readerGroupEA,
    struct REDAExclusiveArea *writerGroupEA,
    struct DISCSimpleEndpointDiscoveryPluginProperty *property,
    struct DISCPluginManager *pluginManager,
    struct REDAWorker *worker);

extern DISCDllExport RTIBool
DISCSimpleEndpointDiscoveryPlugin_enable(
    struct DISCSimpleEndpointDiscoveryPlugin *me,
    struct REDAWorker *worker);

extern DISCDllExport RTIBool
DISCSimpleEndpointDiscoveryPlugin_shutdown(
    struct DISCSimpleEndpointDiscoveryPlugin *me,
    struct REDAWorker *worker);

extern DISCDllExport void
DISCSimpleEndpointDiscoveryPlugin_delete(
    struct DISCSimpleEndpointDiscoveryPlugin *me);

extern DISCDllExport
void DISCSimpleEndpointDiscoveryPlugin_finalizePlugins(void);

extern DISCDllExport struct PRESPsReader *
DISCSimpleEndpointDiscoveryPlugin_getSubscriptionReader(
    struct DISCSimpleEndpointDiscoveryPlugin *me);

extern DISCDllExport struct PRESPsReader *
DISCSimpleEndpointDiscoveryPlugin_getPublicationReader(
    struct DISCSimpleEndpointDiscoveryPlugin *me);


typedef enum {
    DISC_SIMPLE_DISCOVERY_PLUGIN_PARTICIPANT_STATE_ACCEPTED,
    DISC_SIMPLE_DISCOVERY_PLUGIN_PARTICIPANT_STATE_IGNORED,
    DISC_SIMPLE_DISCOVERY_PLUGIN_PARTICIPANT_STATE_UNKNOWN
} DISCSimpleEndpointDiscoveryPluginParticipantStateKind;


struct DISCParticipantState {
    DISCSimpleEndpointDiscoveryPluginParticipantStateKind kind;
    /* the participant who just accepted/ignored/etc the subjectParticipant */
    struct MIGRtpsGuid sourceParticipantGuid;
    /* the participant who just got accepted/ignored/etc by the sourceParticipant */
    struct MIGRtpsGuid subjectParticipantGuid; /* key */
};

extern DISCDllExport
void DISCSimpleParticipantDiscoveryPlugin_delete(
        struct DISCSimpleParticipantDiscoveryPlugin *me);


#ifdef __cplusplus
    }	/* extern "C" */
#endif

#endif /* disc_simple_discovery_plugin_h */
