/* (c) Copyright 2003-2021, Real-Time Innovations, Inc. All rights reserved. */
/*
 * @(#)metp_type_plugin.h    generated by: makeheader    Sat Mar  9 09:50:21 2024
 *
 *		built from:	type_plugin.ifc
 */

#ifndef metp_type_plugin_h
#define metp_type_plugin_h



#define RTI_METP

#ifndef metp_dll_h
#include "metp/metp_dll.h"
#endif

#include "ndds/ndds_c.h"
#include "metp/metp_dds.h"




#ifdef __cplusplus
extern "C" {
#endif

#define METP_ENCAPSULATION_ID_IB_RDMA_READ_BE    0xC100
#define METP_ENCAPSULATION_ID_IB_RDMA_READ_LE    0xC101
#ifdef RTI_ENDIAN_LITTLE
#define METP_ENCAPSULATION_ID_IB_RDMA_READ_NATIVE    METP_ENCAPSULATION_ID_IB_RDMA_READ_LE
#else
#define METP_ENCAPSULATION_ID_IB_RDMA_READ_NATIVE    METP_ENCAPSULATION_ID_IB_RDMA_READ_BE
#endif
    

extern METPDllExport DDS_Boolean 
METPTypePlugin_initializeGlobals(void);

extern METPDllExport void 
METPTypePlugin_finalizeGlobals(void);

extern METPDllExport PRESTypePluginParticipantData 
METypePlugin_on_participant_attached(PRESTypePluginParticipantData epd,
                                     void *registration_data, 
                                     const struct PRESTypePluginParticipantInfo *participant_info,
                                     RTIBool top_level_registration, 
                                     void *container_plugin_context,
                                     RTICdrTypeCode *typeCode);

extern METPDllExport void 
METypePlugin_on_participant_detached(
                                     PRESTypePluginParticipantData participant_data);


#define METypePlugin_getMaxDeserializedSizeFunction PRESTypePluginGetDeserializedSampleMaxSizeFunction

typedef RTIBool (*METypePlugin_initializeSampleFunction)(void*);

extern METPDllExport RTIBool 
METypePlugin_on_endpoint_attached(
        PRESTypePluginParticipantData participant_data,
        PRESTypePluginEndpointData epd,
        const struct PRESTypePluginEndpointInfo *endpoint_info,
        RTIBool top_level_registration, 
        void *container_plugin_context,
        RTI_UINT32 max_deserialized_size,
        METypePlugin_initializeSampleFunction);

extern METPDllExport RTIBool
METypePlugin_return_sample(PRESTypePluginEndpointData endpointData,
                           void *sample,
                           void *handle);

extern METPDllExport void*
METypePlugin_get_sample(PRESTypePluginEndpointData endpointData);

extern METPDllExport void*
METypePlugin_getTempSample(PRESTypePluginEndpointData endpointData);

extern METPDllExport void 
METypePlugin_on_endpoint_detached(PRESTypePluginEndpointData endpoint_data);

extern METPDllExport RTIBool 
METypePlugin_serializeAndSetCdrEncapsulation(PRESTypePluginEndpointData endpoint_data,
                                             struct RTICdrStream *stream,
                                             RTIEncapsulationId encapsulation_id,
                                             RTIBool *oob);

extern METPDllExport RTIBool 
METypePlugin_deserializeAndSetCdrEncapsulation(PRESTypePluginEndpointData endpoint_data,
                                               struct RTICdrStream *stream,
                                               RTIBool *oob);

extern METPDllExport RTIBool 
METypePlugin_validEncapsulationId(RTIEncapsulationId encapsulation_id);

extern METPDllExport unsigned int 
METypePlugin_get_serialized_sample_max_size(
                                            PRESTypePluginEndpointData endpoint_data,
                                            RTIBool include_encapsulation,
                                            RTIEncapsulationId encapsulation_id,
                                            unsigned int size,
                                            RTIBool *oob);

extern METPDllExport unsigned int 
METypePlugin_get_serialized_sample_min_size(
                                            PRESTypePluginEndpointData endpoint_data,
                                            RTIBool include_encapsulation,
                                            RTIEncapsulationId encapsulation_id,
                                            unsigned int size,
                                            RTIBool *oob);

extern METPDllExport unsigned int
METypePlugin_get_serialized_sample_size(
                                        PRESTypePluginEndpointData endpoint_data,
                                        RTIBool include_encapsulation,
                                        RTIEncapsulationId encapsulation_id,
                                        unsigned int current_alignment,
                                        RTIBool *oob);



#ifdef __cplusplus
}	/* extern "C" */
#endif

#include "metp/metp_type_plugin_impl.h"


#endif /* metp_type_plugin_h */
