/* (c) Copyright 2003-2021, Real-Time Innovations, Inc. All rights reserved. */
/*
 * @(#)monitor_log.h    generated by: makeheader    Sat Mar  9 09:50:37 2024
 *
 *		built from:	log.ifc
 */

#ifndef monitor_log_h
#define monitor_log_h


  #ifndef monitor_dll_h
    #include "monitor/monitor_dll.h"
  #endif
  #ifndef log_common_h
    #include "log/log_common.h"
  #endif

#ifdef __cplusplus
    extern "C" {
#endif



/*i \ingroup RTILogNumberBitmapClass 
    \brief Bitmap to specify STATIC DISCOVERY module in log message number.
    
    @see RTI_LOG_MODULE_MASK
 */
#define MODULE_MONITOR  (0x130000)

/*e \ingroup RTI_MonitorLogModule
  Submodule ID for plugin submodule
*/
  #define SUBMODULE_MONITOR_PUBLISHER  (0x1000)


/*e \ingroup RTI_MonitorLogModule
  Mask for turning on logging for only the plugin submodule
*/
  #define MONITOR_SUBMODULE_MASK_PUBLISHER          (0x0001)

/*e \ingroup RTI_MonitorLogModule
  Mask for turning on logging for all submoudles
*/
  #define MONITOR_SUBMODULE_MASK_ALL RTI_LOG_SUBMODULE_MASK_ALL

extern RTIMonitorDllExport
void RTI_Monitor_Log_setDependencyInstrumentationMask(RTILogBitmap verbosity);


#ifdef __cplusplus
    }	/* extern "C" */
#endif

#endif /* monitor_log_h */
