/* $Id$

 (c) Copyright, Real-Time Innovations, 2022.
 All rights reserved.
 No duplications, whole or partial, manual or electronic, may be made
 without express written permission.  Any such copies, or
 revisions thereof, must display this notice unaltered.
 This code contains trade secrets of Real-Time Innovations, Inc.

===================================================================== */

#ifndef monitoring_monitoringDataModel_h
#define monitoring_monitoringDataModel_h

#include "dds_entities_monitoring_id.h"
#include "dds_entities_distribution.h"
#include "dds_entities_distributionSupport.h"
#include "dds_entities_distributionPlugin.h"
#include "dds_logging.h"
#include "dds_loggingSupport.h"
#include "dds_loggingPlugin.h"
#include "rti_remote_administration.h"
#include "rti_remote_administrationPlugin.h"

/**
 * @brief Converts a DDS_Monitoring_GUID_t into a DDS_GUID_t
 */
#define DDS_Monitoring_GUID_as_dds_guid(monitoringGuid__) \
        ((DDS_GUID_t *) (monitoringGuid__))

/**
 * @brief Converts a DDS_GUID_t into a DDS_Monitoring_GUID_t
 */
#define DDS_GUID_as_dds_monitoring_guid(ddsGuid__) \
        ((DDS_Monitoring_GUID_t *) (ddsGuid__))

#define DDS_Monitoring_GUID_DEFAULT {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0}

#endif /* monitoring_monitoringDataModel_h */
/* end of $Id$ */
