/* (c) Copyright 2003-2021, Real-Time Innovations, Inc. All rights reserved. */
/*
 * @(#)ndds_config_common.h    generated by: makeheader    Sat Mar  9 09:39:09 2024
 *
 *		built from:	ndds_config_common.ifc
 */

#ifndef ndds_config_common_h
#define ndds_config_common_h


#ifndef log_common_h
  #include "log/log_common.h"
#endif

#ifdef __cplusplus
extern "C" {
#endif

typedef enum {
    /*e \dref_LogFacility_NDDS_CONFIG_LOG_FACILITY_USER */
    NDDS_CONFIG_LOG_FACILITY_USER = RTI_LOG_FACILITY_USER,
    /*e \dref_LogFacility_NDDS_CONFIG_LOG_FACILITY_SECURITY_EVENT */
    NDDS_CONFIG_LOG_FACILITY_SECURITY_EVENT = RTI_LOG_FACILITY_SECURITY_EVENT,
    /*e \dref_LogFacility_NDDS_CONFIG_LOG_FACILITY_SERVICE */
    NDDS_CONFIG_LOG_FACILITY_SERVICE = RTI_LOG_FACILITY_SERVICE,
    /*e \dref_LogFacility_NDDS_CONFIG_LOG_FACILITY_MIDDLEWARE */
    NDDS_CONFIG_LOG_FACILITY_MIDDLEWARE = RTI_LOG_FACILITY_MIDDLEWARE
} NDDS_Config_LogFacility;

typedef enum {
    /*e \dref_SyslogVerbosity_NDDS_CONFIG_SYSLOG_VERBOSITY_SILENT */
    NDDS_CONFIG_SYSLOG_VERBOSITY_SILENT = RTI_SYSLOG_BITMAP_NONE,
    /*e \dref_SyslogVerbosity_NDDS_CONFIG_SYSLOG_VERBOSITY_EMERGENCY */
    NDDS_CONFIG_SYSLOG_VERBOSITY_EMERGENCY = RTI_SYSLOG_BIT_EMERGENCY,
    /*e \dref_SyslogVerbosity_NDDS_CONFIG_SYSLOG_VERBOSITY_ALERT */
    NDDS_CONFIG_SYSLOG_VERBOSITY_ALERT =
            NDDS_CONFIG_SYSLOG_VERBOSITY_EMERGENCY | RTI_SYSLOG_BIT_ALERT,
    /*e \dref_SyslogVerbosity_NDDS_CONFIG_SYSLOG_VERBOSITY_CRITICAL */
    NDDS_CONFIG_SYSLOG_VERBOSITY_CRITICAL =
            NDDS_CONFIG_SYSLOG_VERBOSITY_ALERT | RTI_SYSLOG_BIT_CRITICAL,
    /*e \dref_SyslogVerbosity_NDDS_CONFIG_SYSLOG_VERBOSITY_ERROR */
    NDDS_CONFIG_SYSLOG_VERBOSITY_ERROR =
            NDDS_CONFIG_SYSLOG_VERBOSITY_CRITICAL | RTI_SYSLOG_BIT_ERROR,
    /*e \dref_SyslogVerbosity_NDDS_CONFIG_SYSLOG_VERBOSITY_WARNING */
    NDDS_CONFIG_SYSLOG_VERBOSITY_WARNING =
            NDDS_CONFIG_SYSLOG_VERBOSITY_ERROR | RTI_SYSLOG_BIT_WARNING,
    /*e \dref_SyslogVerbosity_NDDS_CONFIG_SYSLOG_VERBOSITY_NOTICE */
    NDDS_CONFIG_SYSLOG_VERBOSITY_NOTICE =
            NDDS_CONFIG_SYSLOG_VERBOSITY_WARNING | RTI_SYSLOG_BIT_NOTICE,
    /*e \dref_SyslogVerbosity_NDDS_CONFIG_SYSLOG_VERBOSITY_INFORMATIONAL */
    NDDS_CONFIG_SYSLOG_VERBOSITY_INFORMATIONAL =
            NDDS_CONFIG_SYSLOG_VERBOSITY_NOTICE | RTI_SYSLOG_BIT_INFORMATIONAL,
    /*e \dref_SyslogVerbosity_NDDS_CONFIG_SYSLOG_VERBOSITY_DEBUG */
    NDDS_CONFIG_SYSLOG_VERBOSITY_DEBUG =
            NDDS_CONFIG_SYSLOG_VERBOSITY_INFORMATIONAL | RTI_SYSLOG_BIT_DEBUG
} NDDS_Config_SyslogVerbosity;


#ifdef __cplusplus
} /* extern "C" */
#endif

#endif /* ndds_config_common_h */
