/* (c) Copyright 2003-2021, Real-Time Innovations, Inc. All rights reserved. */
/*
 * @(#)pres_cstReaderCollator.h    generated by: makeheader    Sat Mar  9 09:38:35 2024
 *
 *		built from:	cstReaderCollator.ifc
 */

#ifndef pres_cstReaderCollator_h
#define pres_cstReaderCollator_h


  #ifndef osapi_type_h
    #include "osapi/osapi_type.h"
  #endif
  #ifndef reda_fastBuffer_h
    #include "reda/reda_fastBuffer.h"
  #endif
  #ifndef reda_worker_h
    #include "reda/reda_worker.h"
  #endif
  #ifndef property_propertyNames_h
    #include "property/property_propertyNames.h"
  #endif
  #ifndef commend_readerService_h
    #include "commend/commend_readerService.h"
  #endif
  #ifndef pres_dll_h
    #include "pres/pres_dll.h"
  #endif
  #ifndef pres_common_h
    #include "pres/pres_common.h"
  #endif
  #ifndef pres_readerStatistics_h
    #include "pres/pres_readerStatistics.h"
  #endif
  #ifndef pres_typePlugin_h
    #include "pres/pres_typePlugin.h"
  #endif
  #ifndef pres_participant_h
    #include "pres/pres_participant.h"
  #endif
  #ifndef pres_psReaderWriter_h
    #include "pres/pres_psReaderWriter.h"
  #endif

  #include "pres/pres_readerQueue.h"

#ifdef __cplusplus
    extern "C" {
#endif


#define PRES_CST_READER_COLLATOR_EFFECTIVE_ORDERED_ACCESS_PROPERTY PROPERTY_NAME_DDS_DATA_READER_QUEUE_EFFECTIVE_ORDERED_ACCESS
#define PRES_CST_READER_COLLATOR_EFFECTIVE_ACCESS_SCOPE_PROPERTY PROPERTY_NAME_DDS_DATA_READER_QUEUE_EFFECTIVE_ACCESS_SCOPE

struct PRESCstReaderCollatorRemoteWriterQueue;

struct PRESPsService_QueryConditionState;

struct PRESReaderQueueIndexCondition;

struct PRESCstReaderCollator;

struct PRESCstReaderCollatorProperty {
    /* Properties shared between all reader collators */
    struct PRESReaderQueueProperty parent;

    /*e Virtual Reader GUID */
    struct MIGRtpsGuid virtualReaderGuid;
    
    /*e Control growth in number of samples. */
    struct REDAFastBufferPoolGrowthProperty sampleCount;

    /*e The maximum allowable number of samples per remote writer. */
    int maximalSamplePerRemoteWriterCount;

    /*e Control growth in number of virtual remote writers. */
    struct REDAFastBufferPoolGrowthProperty virtualWriterCount;

    /*e The maximum allowable number of samples per instance. */
    int maximalSamplePerInstanceCount;

    /*e Instance hash buckets. */
    int instanceHashBuckets;

    /*e Control growth in number of instances.
     * Max bound limited by DataReader resource limits::max_instances
     * rwReader->_resourceLimitsQosPolicy.instanceCount.maximal
     */
    struct REDAFastBufferPoolGrowthProperty registeredInstanceCount;
    /*
     * Max bound limited by DataReader resource limits::max_total_instances
     * rwReader->_resourceLimitsQosPolicy.maxTotalInstances
     */
    struct REDAFastBufferPoolGrowthProperty instanceCount;

    /*e Control growth in number of remote writers per instance. */
    struct REDAFastBufferPoolGrowthProperty remoteWriterCountPerInstance;

    /*e Control growth in number of remote writers per instance. */
    struct REDAFastBufferPoolGrowthProperty virtualWriterCountPerInstance;

    /*e Control growth in number of infos. */
    struct REDAFastBufferPoolGrowthProperty infoCount;

    /*e Control growth in number of concurrent reads. */
    struct REDAFastBufferPoolGrowthProperty outstandingReadCount;

    /*e The maximum samples that can be returned from read, to address #9375 */
    int maximalSamplesPerRead;
    /*e The maximum number of QueryConditionFilters allowed per Reader */
    int maximumQueryConditionFilters;
    /*e The reliability QoS. */
    struct PRESReliabilityQosPolicy reliabilityQos;
    /*e The presentation QoS. */
    struct PRESPresentationQosPolicy presentationQos;
    /*e The deadline QoS.
      A period set to RTI_NTP_TIME_MAX is interpreted as infinite.  In addition,
      the period may not exceed PRES_DEADLINE_QOS_POLICY_DEADLINE_PERIOD_MAX. */
    struct PRESDeadlineQosPolicy deadlineQos;
    /*e The ownership QoS. */
    struct PRESOwnershipQosPolicy ownershipQos;
    /*e Indicates whether or not ownership has to be applied based on virtual GUID */
    RTIBool virtualOwnership;
    /* The destination order QoS */
    struct PRESDestinationOrderQosPolicy destinationOrderQos;
    /*e The time based filter QoS.  The minimumSeparation may not exceed 
      PRES_TIME_BASED_FILTER_QOS_POLICY_MINIMUM_SEPARATION_MAX. */
    struct PRESTimeBasedFilterQosPolicy timeBasedFilterQos;
    /*e The history QoS. */
    struct PRESHistoryQosPolicy historyQos;
    /*e The reader data lifecycle QoS. */
    struct PRESReaderDataLifecycleQosPolicy readerDataLifecycleQos;
    /*e The durability Qos */
    struct PRESDurabilityQosPolicy durabilityQos;
    /*e The service Qos */
    struct PRESServiceQosPolicy serviceQos;

    struct PRESTypeSupportQosPolicy typeSupport;

    /*e Restore reader queue state */
    /* This member is used when the reader state can be retrieved from a persistence storage */
    RTIBool restoreState;

    /*e Virtual reliability settings */
    PRESVirtualReliabilityKind virtualReliabilityKind;
    struct PRESAvailabilityQosPolicy availabilityQosPolicy;

    /* This property is used to filter old samples by source timestamp */
    RTIBool filterOldSamples;

    int requestDepth;

    int checkpointFrequency;

    /* Indicates if the dispose of unregister instances must be propagated */
    RTIBool propagateDisposeOfUnregisterInstances;

    /* Indicates if the unregister of disposed instances must be propagated */
    RTIBool propagateUnregisterOfDisposedInstances;

    /*e The maximum allowable number of remote writers per virtual sample */
    int maximalRemoteWritersPerSample;

    /*e When this flag is true the PERSISTENT DataReaders will not communicate reliable 
        with the original writers. Reliability will be done only with persistence services
        writers */
    RTIBool delegateReliability;

    /*e The max length of the payload that can be sent with application
        acknowledgements. Determined by reader resource limits QoS */
    int appAckUserDataMaxLength;

    /*e The minimum time the payload will be available for 
        late-joining writers */
    struct RTINtpTime appAckUserDataMinKeepDuration;

    /* With appAckImmediateSend, batch this number of acks per
       remote writer before sending a message */
    int samplesPerAppAck;
    
    /* The reader count will be needed for GROUP access */
    struct REDAFastBufferPoolGrowthProperty readerCount;

    /* The remote writer count will be needed for GROUP access */
    struct REDAFastBufferPoolGrowthProperty discoveryRemoteWriterCount;
    /* This property is used to force the query condition filter to pass not
     * alive samples, independently of their content. */
    RTIBool _queryConditionAlwaysPassNotAliveSamples;
    /* For Testing Only: Indicates if filtering has to be performed always
       on serialized data */
    RTIBool _alwaysFilterOnSerialized;

    /* Reader data representations: used in operations with keyhashes. */
    PRESDataRepresentationCdrSupportMask cdrSupportMask;

    /* 
     * Configures how instances should be replaced when the max_instances
     * resource limit is hit.
     */
    struct PRESDataReaderResourceLimitsInstanceReplacementSettings instanceReplacementSettings;

    /* Whether or not to purge all state for disposed or unregistered instances
       before reaching the limit imposed by max_total_instances */
    RTIBool keepMinimumStateForInstances;

    /* Indicates if the keyhash generation is secure. This is set to TRUE
     * when data protection kind is set to ENCRYPTION or the test property
     * dds.type_plugin.force_md5_keyhash is set to true
     */
    RTIBool forceMD5KeyHash;

    /* CORE-7714 */
    RTIBool generateSampleHash;

    /* Set to RTI_TRUE when the property
     * "dds.data_reader.deserialize_sample_signature" is set to 1
     */
    RTIBool deserializeSampleSignature;

    /* Topic name of the reader queue CORE-7751 */
    char *topicName;

    /* Topic name of the reader queue CORE-7751 */
    char *typeName;

    /*
     * If the value of acceptWriterRemovedBatchSamples is true the flag
     * 'MIG_RTPS_DATA_BATCH_SAMPLE_INFO_I_FLAG' will be ignored.
     * This flag indicates that a sample was marked as removed by the DataWriter,
     * for example when a sample is replaced because of KEEP_LAST history depth.
     */
    RTIBool acceptWriterRemovedBatchSamples;

    /*
     * If the DataReader receives a batch with samples marked as removed
     * and logWriterRemovedBatchSamples is true:
     * - A message with this information is logged.
     */
    RTIBool logWriterRemovedBatchSamples;

    /*
     * When this property is FALSE, the queue will not generate a 
     * NotAliveNoWriters sample for instances that transition to
     * NOT_ALIVE_NO_WRITERS_STATE
     */
    RTIBool generateNotAliveNoWritersSample;

    /*e The delay before inactive remote writer queues are purged */
    struct RTINtpTime autopurgeRemoteNotAliveWriterDelay;

    /*e
     * Is there an event scheduled to purge the remote not alive writer
     * queues. This will be true as long as there are inactive remote writer
     * queues. Once there are no more inactive remote writer queues the event
     * will be stopped and this will return back to false until another remote
     * writer queue becomes inactive.
     */
    RTIBool isPurgeRemoteNotAliveWriterEventScheduled;
};


#define PRES_CST_READER_COLLATOR_PROPERTY_DEFAULT {      \
    PRES_READER_QUEUE_PROPERTY_DEFAULT, /* parent */ \
    /* virtualReaderGuid */ \
    MIG_RTPS_GUID_UNKNOWN, \
    /* sampleCount */                           \
    {32, REDA_FAST_BUFFER_POOL_UNLIMITED, REDA_FAST_BUFFER_POOL_UNLIMITED}, \
    -1,  /* maximalEntryPerRemoteWriterCount: unlimited */ \
    /* virtualWriterCount */ \
    {2, REDA_FAST_BUFFER_POOL_UNLIMITED, REDA_FAST_BUFFER_POOL_UNLIMITED}, \
    -1,  /* maximalSamplePerInstanceCount: unlimited */     \
    1, /* instanceHashBuckets */ \
    /* registeredInstanceCount */                        \
    {8, REDA_FAST_BUFFER_POOL_UNLIMITED, REDA_FAST_BUFFER_POOL_UNLIMITED}, \
    /* instanceCount */                        \
    {8, REDA_FAST_BUFFER_POOL_UNLIMITED, REDA_FAST_BUFFER_POOL_UNLIMITED}, \
    /* remoteWriterCountPerInstance */ \
    {1, REDA_FAST_BUFFER_POOL_UNLIMITED, REDA_FAST_BUFFER_POOL_UNLIMITED}, \
    /* virtualWriterCountPerInstance */ \
    {1, REDA_FAST_BUFFER_POOL_UNLIMITED, REDA_FAST_BUFFER_POOL_UNLIMITED}, \
    /* infoCount */ \
    {32, REDA_FAST_BUFFER_POOL_UNLIMITED, REDA_FAST_BUFFER_POOL_UNLIMITED}, \
    /* outstandingReadCount */ \
    {1, REDA_FAST_BUFFER_POOL_UNLIMITED, REDA_FAST_BUFFER_POOL_UNLIMITED}, \
    256, /* maximalSamplesPerRead */                       \
    0, /* maximumQueryConditionFilters */                  \
    PRES_BEST_EFFORT_RELIABILITY_QOS_POLICY_DEFAULT,     \
    {PRES_TOPIC_PRESENTATION_QOS,RTI_FALSE,RTI_TRUE, RTI_TRUE},      \
    {RTI_NTP_TIME_MAX},                                    \
    {PRES_SHARED_OWNERSHIP_QOS},                           \
    RTI_FALSE,                                             \
    {PRES_BY_RECEPTION_TIMESTAMP_DESTINATIONORDER_QOS,     \
     PRES_INSTANCE_SCOPE_DESTINATIONORDER_QOS,             \
     {30, 0} },                                    \
    {RTI_NTP_TIME_ZERO},                                   \
    PRES_HISTORY_QOS_POLICY_DEFAULT, \
    PRES_READER_DATA_LIFECYCLE_QOS_POLICY_DEFAULT,/* readerDataLifecycleQos */ \
    PRES_DURABILITY_QOS_POLICY_DEFAULT, /* durability qos policy */\
    {PRES_NO_SERVICE_QOS}, /* service qos policy */\
    PRES_TYPE_SUPPORT_QOS_POLICY_DEFAULT, /* typeSupport */\
    RTI_FALSE, \
    PRES_BEST_EFFORT_VIRTUAL_RELIABILITY, /* virtualReliabilityKind */ \
    PRES_AVAILABILITY_QOS_POLICY_DEFAULT, /* availabilityQosPolicy */ \
    RTI_FALSE, /* filterOldSamples */ \
    0, /* requestDepth */ \
    1, /* checkpointFrequency */ \
    RTI_FALSE, /* propagateDisposeOfUnregisterInstances */ \
    RTI_FALSE, /* propagateUnregisterOfDisposedInstances */ \
    5, \
    RTI_FALSE, \
    0, /* appAckUserDataMaxLength */ \
    RTI_NTP_TIME_ZERO, /* appAckUserDataMinKeepDuration */ \
    1, /* samplesPerAppAck */ \
    {32, REDA_FAST_BUFFER_POOL_UNLIMITED, REDA_FAST_BUFFER_POOL_UNLIMITED}, /* readerCount */ \
    {32, REDA_FAST_BUFFER_POOL_UNLIMITED, REDA_FAST_BUFFER_POOL_UNLIMITED}, /* discoveryRemoteWriterCount */ \
    RTI_FALSE, /* _queryConditionAlwaysPassNotAliveSamples */\
    RTI_FALSE, /* _alwaysFilterOnSerialized */ \
    PRES_DATA_REPRESENTATION_CDR_SUPPORT_MASK_INVALID, /* cdrSupportMask */ \
    PRESPsReaderDataReaderResourceLimitsInstanceReplacementSettings_INITIALIZER, /* instanceReplacementPolicy */\
    RTI_TRUE, /* keepMinimumStateForInstances */ \
    RTI_FALSE, /* forceMD5KeyHash */ \
    RTI_FALSE, /* generateSampleHash */ \
    RTI_FALSE, /* deserializeSampleSignature */ \
    NULL, /* topicName */ \
    NULL, /* typeName */ \
    PRES_READER_ACCEPT_WRITER_REMOVED_BATCH_SAMPLES_DEFAULT, /* acceptWriterRemovedBatchSamples */ \
    PRES_READER_LOG_WRITER_REMOVED_BATCH_SAMPLES_DEFAULT, /* logWriterRemovedBatchSamples */ \
    RTI_TRUE, /* generateNotAliveNoWritersSample */ \
    RTI_NTP_TIME_AUTO, /* autopurgeRemoteNotAliveWriterDelay */ \
    RTI_FALSE /* isPurgeRemoteNotAliveWriterEventScheduled */ \
}

extern PRESDllExport RTIBool
PRESCstReaderCollator_hasOutstandingLoans(
    struct PRESCstReaderCollator *me,
    struct REDAWorker *worker);

  
    #define PRES_CST_READER_COLLATOR_READ_TAKE_MAX_COUNT_UNLIMITED (-1)

extern PRESDllExport RTIBool
PRESCstReaderCollator_take(
    struct PRESCstReaderCollator *me, int *successReason,
    void ***dataArray, int *dataCount,
    struct PRESLoanedSampleInfo ***infoArray, int *infoCount, int maxCount,
    PRESSampleStateMask sMask,
    PRESViewStateMask vMask,
    PRESInstanceStateMask iMask,
    int filterIndex,
    struct PRESReaderQueueIndexCondition * indexCondition,
    RTI_UINT32 *readConditionState,
    struct PRESPsService_QueryConditionState *queryConditionState,
    struct REDAWorker *worker);

extern PRESDllExport RTIBool
PRESCstReaderCollator_read(
    struct PRESCstReaderCollator *me, int *successReason,
    void ***dataArray, int *dataCount,
    struct PRESLoanedSampleInfo ***infoArray, int *infoCount, int maxCount,
    PRESSampleStateMask sMask,
    PRESViewStateMask vMask,
    PRESInstanceStateMask iMask,
    int filterIndex,
    struct PRESReaderQueueIndexCondition * indexCondition,
    RTI_UINT32 *readConditionState,
    struct PRESPsService_QueryConditionState *queryConditionState,
    struct REDAWorker *worker);

extern PRESDllExport void
PRESCstReaderCollator_finish(
    struct PRESCstReaderCollator *me,
    struct PRESLoanedSampleInfo **infoArray, int infoCount,
    RTI_UINT32 *readConditionState,
    struct PRESPsService_QueryConditionState *queryConditionState,
    struct REDAWorker *worker);

extern PRESDllExport RTIBool
PRESCstReaderCollator_takeInstance(
    struct PRESCstReaderCollator *me, int *successReason, int *failReason,
    void ***dataArray, int *dataCount,
    struct PRESLoanedSampleInfo ***infoArray, int *infoCount,
    int maxCount, const struct PRESInstanceHandle *handle,
    PRESSampleStateMask sMask,
    PRESViewStateMask vMask,
    PRESInstanceStateMask iMask,
    int filterIndex,
    RTI_UINT32 *readConditionState,
    struct PRESPsService_QueryConditionState *queryConditionState,
    struct REDAWorker *worker);

extern PRESDllExport RTIBool
PRESCstReaderCollator_readInstance(
    struct PRESCstReaderCollator *me, int *successReason, int *failReason,
    void ***dataArray, int *dataCount,
    struct PRESLoanedSampleInfo ***infoArray, int *infoCount,
    int maxCount, const struct PRESInstanceHandle *handle,
    PRESSampleStateMask sMask,
    PRESViewStateMask vMask,
    PRESInstanceStateMask iMask,
    int filterIndex,
    RTI_UINT32 *readConditionState,
    struct PRESPsService_QueryConditionState *queryConditionState,
    struct REDAWorker *worker);

extern PRESDllExport RTIBool
PRESCstReaderCollator_takeNextSample(
    struct PRESCstReaderCollator *me, RTIBool *validSample,
    void *data, struct PRESSampleInfo *info,
    RTI_UINT32 *readConditionState,
    struct PRESPsService_QueryConditionState *queryConditionState,
    struct REDAWorker *worker);

extern PRESDllExport RTIBool
PRESCstReaderCollator_readNextSample(
    struct PRESCstReaderCollator *me, RTIBool *validSample,
    void *data, struct PRESSampleInfo *info,
    RTI_UINT32 *readConditionState,
    struct PRESPsService_QueryConditionState *queryConditionState,
    struct REDAWorker *worker);

extern PRESDllExport RTIBool
PRESCstReaderCollator_getKey(
    struct PRESCstReaderCollator *me, int *failReason, void *instance,
    const struct PRESInstanceHandle *handle, struct REDAWorker *worker);

extern PRESDllExport RTIBool
PRESCstReaderCollator_getKeyX(
    struct PRESCstReaderCollator *me, int *failReason, void *key,
    const struct PRESInstanceHandle *handle, struct REDAWorker *worker);

extern PRESDllExport struct REDAInlineListUserDataNode *
PRESCstReaderCollatorRemoteWriterQueue_getNode(
    struct PRESCstReaderCollatorRemoteWriterQueue * queue);

extern PRESDllExport struct PRESCstReaderCollator *
PRESCstReaderCollatorRemoteWriterQueue_getReaderQueue(
    struct PRESCstReaderCollatorRemoteWriterQueue * queue);

typedef RTI_UINT32 PRESCstReaderCollatorRemoteWriterQueueStateMask;


#define PRES_CST_READER_COLLATOR_REMOTE_WRITER_QUEUE_STATE_ACTIVE 1
#define PRES_CST_READER_COLLATOR_REMOTE_WRITER_QUEUE_STATE_INACTIVE 2
#define PRES_CST_READER_COLLATOR_REMOTE_WRITER_QUEUE_STATE_ALL \
    (PRES_CST_READER_COLLATOR_REMOTE_WRITER_QUEUE_STATE_INACTIVE \
            | PRES_CST_READER_COLLATOR_REMOTE_WRITER_QUEUE_STATE_ACTIVE)

extern PRESDllExport
struct PRESCstReaderCollatorRemoteWriterQueue * PRESCstReaderCollator_findRemoteWriterQueue(
        const struct PRESCstReaderCollator *me,
        const struct MIGRtpsGuid *virtualGuid,
        PRESCstReaderCollatorRemoteWriterQueueStateMask queueStates);

extern PRESDllExport void 
PRESCstReaderCollator_activateRemoteWriterQueue(
    struct PRESCstReaderCollator *me, 
    struct PRESCstReaderCollatorRemoteWriterQueue *remoteWriterQueue);

extern PRESDllExport void 
PRESCstReaderCollator_addQueryConditionFilter(
    struct PRESCstReaderCollator *me,
    int index,
    RTI_UINT32 systemKey,
    void *handle,
    PRESContentFilterEvaluate evaluate,
    PRESContentFilterEvaluate evaluateOnSerialized,
    void *filterData,
    RTIBool isKeyOnlyFilter,
    RTIBool isBuiltin,
    struct PRESPsService_QueryConditionState *queryConditionState);

extern PRESDllExport
RTINtpTime PRESCstReaderCollator_getAutopurgeRemoteNotAliveWriterDelay(
        struct PRESCstReaderCollator *self);

extern PRESDllExport
struct MIGRtpsGuid PRESCstReaderCollator_getReaderGuid(
        struct PRESCstReaderCollator *self);

extern PRESDllExport
MIGRtpsObjectId PRESCstReaderCollator_getReaderGroupOid(
        struct PRESCstReaderCollator *self);

extern PRESDllExport
RTIBool PRESCstReaderCollator_isPurgeRemoteNotAliveWriterEventScheduled(
        struct PRESCstReaderCollator *self);

extern PRESDllExport
void PRESCstReaderCollator_setIsPurgeRemoteNotAliveWriterEventScheduled(
        struct PRESCstReaderCollator *self,
        RTIBool isPurgeRemoteNotAliveWriterEventScheduled);

extern PRESDllExport void 
PRESCstReaderCollator_removeQueryConditionFilter(
    struct PRESCstReaderCollator *me, int index);

typedef RTIBool (*PRESCstReaderCollatorTransformSampleFunction)(
    void *out, const void *in, void *transformOption);

typedef enum {
    PRES_CST_READER_COLLATOR_SAMPLE_KIND_DATA       = 0x00,
    PRES_CST_READER_COLLATOR_SAMPLE_KIND_DISPOSED   = 0x01,
    PRES_CST_READER_COLLATOR_SAMPLE_KIND_NO_WRITERS = 0x02
} PRESCstReaderCollatorSampleKind;

extern PRESDllExport RTIBool 
PRESCstReaderCollator_addSample(
    struct PRESCstReaderCollator *me, 
    RTIBool *dataAvailable, RTIBool *sampleLost, 
    PRESSampleLostStatusKind *lostReason,
    RTIBool *sampleRejected, 
    PRESSampleRejectedStatusKind *rejectedReason, 
    struct MIGRtpsKeyHash *rejectedInstanceKeyHash,
    PRESCstReaderCollatorTransformSampleFunction transformFnc, 
    const void *data, void *transformOption,
    const struct MIGRtpsGuid *remoteWriterGuid, 
    const struct MIGRtpsKeyHash *keyHash,
    const struct RTINtpTime *sourceTimestamp, 
    PRESCstReaderCollatorSampleKind sampleKind, 
    const struct RTINtpTime *receptionTimestamp, 
    const struct RTINtpTime *now, 
    RTI_UINT32 *readConditionState,
    struct PRESPsService_QueryConditionState *queryConditionState,
    struct REDAWorker *worker);

extern PRESDllExport RTIBool 
PRESCstReaderCollator_newAnonData(
    struct PRESCstReaderCollator *me,
    RTIBool *dataAvailable, int *lostCount, 
    PRESSampleLostStatusKind *lostReason,
    int *rejectedCount,
    PRESSampleRejectedStatusKind *rejectedReason,
    struct MIGRtpsKeyHash *rejectedInstanceKeyHash,
    struct COMMENDReaderServiceData *data,
    const struct RTINtpTime *timestamp,
    const struct RTINtpTime *now,
    RTI_UINT32 *readConditionState,
    struct PRESPsService_QueryConditionState *queryConditionState,
    const struct PRESParticipant *presParticipant,
    struct REDAWorker *worker);

extern PRESDllExport RTIBool 
PRESCstReaderCollator_newData(
    struct PRESCstReaderCollator *me,
    RTIBool *dataAvailable, 
    RTIBool *droppedSampleOutsideReaderResourceLimits,
    int *lostCount, 
    PRESSampleLostStatusKind *lostReason,
    int *rejectedCount,
    PRESSampleRejectedStatusKind *rejectedReason,
    struct MIGRtpsKeyHash *rejectedInstanceKeyHash,
    int *receivedInlineQosBitmap,
    struct PRESCstReaderCollatorRemoteWriterQueue *remoteWriterQueue,
    const struct REDASequenceNumber *firstRelevantSn,
    const struct REDASequenceNumber *firstRelevantRangeEndSn,
    struct COMMENDReaderServiceData *data, 
    const struct PRESReaderServiceLocalData *localData,
    void *decodingKeyHandle,
    int strength,
    int reservedCount,
    const struct RTINtpTime *timestamp,
    const struct RTINtpTime *now,
    RTI_UINT32 *readConditionState,
    struct PRESPsService_QueryConditionState *queryConditionState,
    const struct PRESParticipant *presParticipant,
    struct REDAWorker *worker);

extern PRESDllExport RTIBool 
PRESCstReaderCollator_commitData(
    struct PRESCstReaderCollator *me,
    int *lostCount, 
    PRESSampleLostStatusKind *lostReason,
    int *rejectedCount,
    PRESSampleRejectedStatusKind *rejectedReason,
    struct MIGRtpsKeyHash *rejectedInstanceKeyHash,
    struct PRESCstReaderCollatorRemoteWriterQueue *remoteWriterQueue,
    const struct REDASequenceNumber *firstRelevantSn,
    int reservedCount,
    const struct RTINtpTime *timestamp,
    const struct RTINtpTime *now,
    RTI_UINT32 *readConditionState,
    struct PRESPsService_QueryConditionState *queryConditionState,
    struct REDAWorker *worker);

extern PRESDllExport RTIBool 
PRESCstReaderCollator_lostData(
    struct PRESCstReaderCollator *me,
    int *lostCount, 
    PRESSampleLostStatusKind *lostReason,
    int *rejectedCount,
    PRESSampleRejectedStatusKind *rejectedReason,
    struct MIGRtpsKeyHash *rejectedInstanceKeyHash,
    struct PRESCstReaderCollatorRemoteWriterQueue *remoteWriterQueue,
    const struct REDASequenceNumber *firstRelevantSn,
    int reservedCount,
    const struct RTINtpTime *timestamp,
    const struct RTINtpTime *now,
    RTI_UINT32 *readConditionState,
    struct PRESPsService_QueryConditionState *queryConditionState,
    struct REDAWorker *worker);

extern PRESDllExport int 
PRESCstReaderCollator_getFreeCount(
    struct PRESCstReaderCollator *me,
    struct PRESCstReaderCollatorRemoteWriterQueue *remoteWriterQueue,
    struct REDAWorker *worker);

extern PRESDllExport RTIBool 
PRESCstReaderCollator_retryCommittal(
    struct PRESCstReaderCollator *me,
    int *lostCount, 
    PRESSampleLostStatusKind *lostReason,
    int *rejectedCount,
    PRESSampleRejectedStatusKind *rejectedReason,
    struct MIGRtpsKeyHash *rejectedInstanceKeyHash,
    const struct RTINtpTime *timestamp,
    const struct RTINtpTime *now,
    RTI_UINT32 *readConditionState,
    struct PRESPsService_QueryConditionState *queryConditionState,
    struct REDAWorker *worker);

extern PRESDllExport void
PRESCstReaderCollator_lookupInstance(struct PRESCstReaderCollator *me,
                                     const void* key_holder,
                                     struct PRESInstanceHandle *handle);

extern PRESDllExport void
PRESCstReaderCollator_lookupInstanceX(struct PRESCstReaderCollator *me,
                                      const void* key_holder,
                                      struct PRESInstanceHandle *handle);

extern PRESDllExport void 
PRESCstReaderCollator_setMinimumSeparation(
    struct PRESCstReaderCollator *me, 
    const struct RTINtpTime *minimumSeparation);

extern PRESDllExport void 
PRESCstReaderCollator_setDeadlinePeriod(
    struct PRESCstReaderCollator *me, 
    const struct RTINtpTime *deadlinePeriod);

extern PRESDllExport void 
PRESCstReaderCollator_setContentFilterPolicy(
    struct PRESCstReaderCollator *me, 
    const struct PRESContentFilterQosPolicy *policy);

struct PRESLoanedSampleInfoListener;

extern PRESDllExport void
PRESCstReaderCollator_preDelete(struct PRESCstReaderCollator *me);

extern PRESDllExport void 
PRESCstReaderCollatorRemoteWriterQueue_getNextCommittalSn(
        const struct PRESCstReaderCollatorRemoteWriterQueue *remoteWriterQueue,
        struct REDASequenceNumber *nextCommittalSn);

extern PRESDllExport
void PRESCstReaderCollator_getStatistics(
        struct PRESCstReaderCollator *me,
        struct PRESPsDataReaderCacheStatus *stats);

extern PRESDllExport void 
PRESCstReaderCollator_setStatistics(
    struct PRESCstReaderCollator *me, 
    const struct PRESPsDataReaderCacheStatus *stats);

extern PRESDllExport struct PRESReaderQueueVirtualWriterList *
PRESCstReaderCollator_getVirtualWriterList(
    struct PRESCstReaderCollator *me);

extern PRESDllExport
RTIBool PRESCstReaderCollator_acknowledgeVirtualSamples(
    struct PRESCstReaderCollator * self,
    struct PRESReaderQueueVirtualWriter * virtualWriter,
    const struct MIGRtpsGuid * virtualWriterGuid,
    const struct REDASequenceNumber * firstSn,
    const struct REDASequenceNumber * lastSn,
    const struct REDABuffer * userData);

extern PRESDllExport
RTIBool PRESCstReaderCollator_acknowledgeAllReadSamples(
    struct PRESCstReaderCollator * self,
    const struct REDABuffer * userData);

extern PRESDllExport
RTIBool PRESCstReaderCollator_confirmAcknowledgement(
    struct PRESCstReaderCollator * self,
    const struct MIGRtpsGuid * remoteWriterGuid,
    struct MIGRtpsAppAck * appAckConf,
    const struct RTINtpTime * now);

extern PRESDllExport
RTIBool PRESCstReaderCollatorRemoteWriterQueue_getAcknowledgementState(
    struct PRESCstReaderCollatorRemoteWriterQueue * self,
    struct MIGRtpsAppAck * appAckOut);

extern PRESDllExport
RTIBool PRESCstReaderCollator_newWriterInfo(
    struct PRESCstReaderCollator *me,
    int *lostCount, 
    PRESSampleLostStatusKind *lostReason,
    int *rejectedCount,
    PRESSampleRejectedStatusKind *rejectedReason,
    struct MIGRtpsKeyHash *rejectedInstanceKeyHash,
    RTIBool * newVirtualWriter,
    struct PRESCstReaderCollatorRemoteWriterQueue *remoteWriterQueue,
    const struct RTINtpTime *timestamp,
    const struct RTINtpTime *now,
    RTI_UINT32 *readConditionState,
    struct PRESPsService_QueryConditionState *queryConditionState,
    const struct MIGRtpsWriterInfoList *writerInfoList,
    struct REDAWorker *worker);

extern PRESDllExport
struct REDAInlineList *
    PRESCstReaderCollator_getCommittalInfoList(
        struct PRESCstReaderCollator * me);

extern PRESDllExport
struct PRESReaderQueueCommittalInfo *
    PRESCstReaderCollator_getCommittalInfo(
        struct PRESCstReaderCollator * me);

extern PRESDllExport
RTIBool    
PRESCstReaderCollator_getRetryCommitForRejectedSamples(
    struct PRESCstReaderCollator * me);

extern PRESDllExport
void   
PRESCstReaderCollator_resetRetryCommitForRejectedSamples(
    struct PRESCstReaderCollator * me);

extern PRESDllExport
RTIBool
PRESCstReaderCollatorRemoteWriterQueue_getRetryCommittal(
    struct PRESCstReaderCollatorRemoteWriterQueue *me);

extern PRESDllExport
void
PRESCstReaderCollatorRemoteWriterQueue_resetRetryCommittal(
    struct PRESCstReaderCollatorRemoteWriterQueue *me);


struct PRESPsReader;

extern PRESDllExport 
struct PRESReaderQueueIndexCondition *
PRESCstReaderCollator_createIndexCondition(
        struct PRESCstReaderCollator * self,
        struct PRESPsReader *owner,
        const char * indexName,
        struct PRESLoanedSampleInfo * presSampleInfo,
        PRESSampleStateMask sMask,
        PRESViewStateMask vMask,
        PRESInstanceStateMask iMask);

extern PRESDllExport
RTIBool PRESCstReaderCollator_containsIndexCondition(
        struct PRESCstReaderCollator * self,
        struct PRESPsReader *owner,
        struct PRESReaderQueueIndexCondition * presCondition);

extern PRESDllExport 
RTIBool PRESCstReaderCollator_deleteIndexCondition(
        struct PRESCstReaderCollator * self,
        struct PRESPsReader *owner,
        struct PRESReaderQueueIndexCondition * presCondition);

extern PRESDllExport 
RTIBool
PRESCstReaderCollator_createIndex(
        struct PRESCstReaderCollator * self,
        const char * index_name,
        REDAOrderedDataTypeCompareFunction compareFnc,
        struct REDAExclusiveArea* conditionEa,
        int indexConditionUserObjectSize,
        int indexConditionUserObjectAlignment);

extern PRESDllExport 
RTIBool
PRESCstReaderCollator_deleteIndex(
        struct PRESCstReaderCollator * self,
        const char * index_name);

extern PRESDllExport 
void PRESCstReaderCollator_getIndexConditionLists(
   struct PRESCstReaderCollator * self,
   struct REDAInlineList ** outActiveList,
   struct REDAInlineList **outInactivatedList);

extern PRESDllExport 
RTI_UINT32 PRESCstReaderCollator_getReadConditionState(
        struct PRESCstReaderCollator * self);

struct PRESPsService_QueryConditionState;

extern PRESDllExport 
void PRESCstReaderCollator_getQueryConditionState(
         struct PRESCstReaderCollator * self,
         struct PRESPsService_QueryConditionState *queryConditionState);

extern PRESDllExport 
RTIBool PRESCstReaderCollator_isInstanceRegistered(
    struct PRESCstReaderCollator *me,
    const struct PRESInstanceHandle *handle);

extern PRESDllExport
RTIBool PRESCstReaderCollator_processInstanceStateResponse(
        struct PRESCstReaderCollator *me,
        RTIBool *dataAvailable,
        RTI_UINT32 *readConditionState,
        struct PRESPsService_QueryConditionState *queryConditionState,
        const struct NDDS_WriterHistory_InstanceStateDataResponse *responseSample,
        const RTINtpTime *now,
        struct REDAWorker *worker);


#ifdef __cplusplus
    }	/* extern "C" */
#endif


#endif /* pres_cstReaderCollator_h */
