/* (c) Copyright 2003-2021, Real-Time Innovations, Inc. All rights reserved. */
/*
 * @(#)pres_readerQueue_impl.h    generated by: makeheader    Sat Mar  9 09:38:36 2024
 *
 *		built from:	readerQueue_impl.ifc
 */

#ifndef pres_readerQueue_impl_h
#define pres_readerQueue_impl_h



#ifdef __cplusplus
    extern "C" {
#endif


  #ifndef RTI_PRECONDITION_TEST
    #define PRESReaderQueueComittalInfo_reset PRESReaderQueueComittalInfo_resetMacro
  #endif /* !RTI_PRECONDITION_TEST */

#define PRESReaderQueueComittalInfo_resetMacro(ci) \
      (ci)->dataAvailable = RTI_FALSE; \
      (ci)->lostCount = 0; \
      (ci)->lostReason = PRES_NOT_LOST; \
      (ci)->rejectedCount = 0; \
      (ci)->rejectedReason = PRES_NOT_REJECTED; \
      MIGRtpsKeyHash_setDefault(&(ci)->rejectedInstanceKeyHash); \
      (ci)->readConditionState = 0; \
      (ci)->queryConditionState.summary = 0

#define PRESReaderQueue_isV1(me) \
    (((me)->_property.cdrSupportMask \
            & PRES_DATA_REPRESENTATION_CDR_SUPPORT_FLAG_CDR_V1) != 0)

#define PRESReaderQueue_getNativeCdrEncapsulationId(me) \
    (PRESReaderQueue_isV1((me))? \
            RTI_CDR_ENCAPSULATION_ID_CDR_NATIVE: \
            RTI_CDR_ENCAPSULATION_ID_CDR2_NATIVE)

#define PRESReaderQueue_initCdrStream(me, stream) \
    RTICdrStream_initMacro((stream)); \
    RTIOsapiUtility_unusedReturnValue( \
            RTICdrStream_setCdrEncapsulation( \
                    (stream), \
                    PRESReaderQueue_getNativeCdrEncapsulationId((me))), \
                    RTIBool)

#define PRESReaderQueueCoherentSetInfo_fromMigCoherentSetInfo(self, other) \
    (self)->setFirstSn = (other)->setFirstSn; \
    (self)->groupSetFirstSn = (other)->groupSetFirstSn



#ifdef __cplusplus
    }	/* extern "C" */
#endif

#endif /* pres_readerQueue_impl_h */
