/* (c) Copyright 2003-2021, Real-Time Innovations, Inc. All rights reserved. */
/*
 * @(#)pres_typePlugin.h    generated by: makeheader    Sat Mar  9 09:38:37 2024
 *
 *		built from:	typePlugin.ifc
 */

#ifndef pres_typePlugin_h
#define pres_typePlugin_h


 #ifndef pres_dll_h
    #include "pres/pres_dll.h"
 #endif
 #ifndef osapi_type_h
    #include "osapi/osapi_type.h"
 #endif
 #ifndef reda_fastBuffer_h
    #include "reda/reda_fastBuffer.h"
 #endif
 #ifndef property_propertyNames_h
    #include "property/property_propertyNames.h"
 #endif
 #ifndef cdr_stream_h
    #include "cdr/cdr_stream.h"
 #endif
 #ifndef cdr_encapsulation_h
    #include "cdr/cdr_encapsulation.h"
 #endif
 #ifndef commend_writeService_h
    #include "commend/commend_writerService.h"
 #endif
 #ifndef pres_common_h
    #include "pres/pres_common.h"
 #endif
 #ifndef pres_participant_h
    #include "pres/pres_participant.h"
 #endif
 #ifndef cdr_typeCode_h
    #include "cdr/cdr_typeCode.h"
 #endif 
 #include "xcdr/xcdr_interpreter.h"

 #ifndef writer_history_interface_h
    #include "writer_history/writer_history_interface.h"
 #endif 

#ifdef __cplusplus
    extern "C" {
#endif

struct PRESTypePlugin;

typedef struct PRESProperty PRESTypePluginAttribute;

struct PRESTypePluginAttributeList {
       RTI_UINT32 _length;

       PRESTypePluginAttribute *_list;
};

extern PRESDllExport RTI_UINT32
PRESTypePluginAttributeListHelper_getLength(
    const struct PRESTypePluginAttributeList *attributeList);

extern PRESDllExport PRESTypePluginAttribute *
PRESTypePluginAttributeListHelper_getPropertyArray(
    const struct PRESTypePluginAttributeList *attributeList);

extern PRESDllExport const char *
PRESTypePluginAttributeListHelper_getPropertyValue(
    const struct PRESTypePluginAttributeList *attributeList,
    const char *propertyName);

extern PRESDllExport RTI_INT32
PRESTypePluginAttributeListHelper_getPropertyValueAsBool(
    RTIBool * value,
    const struct PRESTypePluginAttributeList *attributeList,
    const char *propertyName);

extern PRESDllExport RTI_INT32
PRESTypePluginAttributeListHelper_getPropertyValueAsInt(
    int * value,
    const struct PRESTypePluginAttributeList *attributeList,
    const char *propertyName);


#define PRES_TYPE_PLUGIN_ATTRIBUTE_LIST_DEFAULT { \
    0, /* length */\
    NULL /* list */\
}

typedef enum {
    /*e Instance doesn't have key concept. User data sent as ISSUE. */
    PRES_TYPEPLUGIN_NO_KEY,
    /*e Instance with GUID as the key. User data sent as VAR */
    PRES_TYPEPLUGIN_GUID_KEY,
    /*e Instance with random key contained in the instance structure.
        User data send as VAR */
    PRES_TYPEPLUGIN_USER_KEY
} PRESTypePluginKeyKind;

typedef enum {
	/*e Java language */
	PRES_TYPEPLUGIN_JAVA_LANG = 0x4A415641,
	/* C DDS type */
	PRES_TYPEPLUGIN_DDS_TYPE = 0x00561234,
	/* C++ DDS type */
	PRES_TYPEPLUGIN_CPP_LANG = 0x00432B2B,
	/* C++03/11 STL DDS type */
	PRES_TYPEPLUGIN_CPPSTL_LANG = 0x00341D1D,
	/* C/C++ non-DDS type */
	PRES_TYPEPLUGIN_NON_DDS_TYPE = 0x00982467,
	/* FLAT_DATA type */
	PRES_TYPEPLUGIN_FLATDATA_TYPE = 0x00004644,
	/* Dynamic Data type */
	PRES_TYPEPLUGIN_DYNDATA_TYPE = 0x0044594E,
	/* Unknown */
	PRES_TYPEPLUGIN_UNKNOWN_LANG = 0x554E4B4E
} PRESTypePluginLanguageKind;

 
typedef struct RTIXCdrSampleAssignabilityProperty
    PRESTypePluginSampleAssignabilityProperty;


#define PRES_TYPE_PLUGIN_SAMPLE_ASSIGNABILITY_PROPERTY_DEFAULT \
    RTIXCdrSampleAssignabilityProperty_INITIALIZER

typedef void* PRESTypePluginEndpointData;

typedef void* PRESTypePluginParticipantData;

struct PRESTypePluginParticipantInfo {
    struct PRESTypePluginAttributeList participantProperties;

    void *pluginData;
    void *reserved;
};


#define PRES_TYPE_PLUGIN_PARTICIPANT_INFO_DEFAULT { \
    PRES_TYPE_PLUGIN_ATTRIBUTE_LIST_DEFAULT, /* participantProperties */\
    NULL, /* pluginData */\
    NULL /* reserved */\
}


typedef enum {
    PRES_TYPEPLUGIN_ENDPOINT_UNKNOWN,
    PRES_TYPEPLUGIN_ENDPOINT_READER,
    PRES_TYPEPLUGIN_ENDPOINT_WRITER
} PRESTypePluginEndpointKind;

extern PRESDllExport
int PRESTypePlugin_getCdrPoolThresholdFromProperty(
    const struct PRESTypePluginAttributeList *attributeList,
    PRESTypePluginEndpointKind endpointKind);

struct PRESTypePluginEndpointInfo {
    PRESTypePluginEndpointKind endpointKind;
    struct PRESInstanceHandle endpointHandle;

    int initialSamples;
    int maxSamples;

    RTIBool isKeyed;
    int initialInstances;
    int maxInstances;

    RTIBool batchEnabled;
    int maxSamplesPerBatch;
    int maxDataBytesPerBatch;
    int initialBatches;
    int maxBatches;

    /* For DataWriters, when set to RTI_TRUE the keyhash calculated by the
     * to_keyhash TypePlugin function will always be based on applying MD5 to
     * the serialized key.
     */
    RTIBool requireMD5KeyHash;

    struct PRESTypePluginAttributeList endpointProperties;

    void *pluginData;

    /* # of supported encapsulations. 0 == all CDR_NATIVE */
    int encapsulationCount; 
    struct RTIEncapsulationInfo *encapsulations; /* array */
    
    struct PRESTypePlugin *typePlugin;

    void *reserved;

    /* (Reader) Indicates if loaned fstSampleDataPool is used */
    RTIBool usesFstSampleDataPool;

    /* (Writer) Indicates if the payload will be encoded */
    RTIBool isPayloadProtected;

    /* (Writer) Pointer to the compression plugin if compression is needed */
    RTIOsapiCompressionPlugin *compressionPlugin;
};


#define PRES_TYPE_PLUGIN_ENDPOINT_INFO_DEFAULT { \
    PRES_TYPEPLUGIN_ENDPOINT_UNKNOWN, /* endpointKind */\
    PRESInstanceHandle_INITIALIZER,   /* entityHandle */\
    2,                                /* initialSamples */\
    REDA_FAST_BUFFER_POOL_UNLIMITED,  /* maxSamples: unlimited */\
    RTI_TRUE,                         /* isKeyed */\
    2,                                /* initialInstances */\
    REDA_FAST_BUFFER_POOL_UNLIMITED,  /* maxInstances: unlimited */\
    RTI_FALSE,                        /* batchEnabled */\
    PRES_LENGTH_UNLIMITED,            /* batchMaxSampleCount */\
    PRES_LENGTH_UNLIMITED,            /* batchMaxSize */\
    2,                                /* initialBatches */\
    PRES_LENGTH_UNLIMITED,            /* maxBatches */\
    RTI_FALSE,                        /* requireMD5KeyHash */\
    PRES_TYPE_PLUGIN_ATTRIBUTE_LIST_DEFAULT, /* endpointProperties */\
    NULL,                             /* pluginData */\
    0,                                /* encapsulationCount */ \
    NULL,                             /* encapsulations (array) */ \
    NULL,                             /* typePlugin*/ \
    NULL,                             /* reserved */\
    RTI_FALSE,                        /* usesFstSampleDataPool */\
    RTI_FALSE,                        /* isPayloadProtected */\
    NULL                              /* compressionPlugin */\
}

typedef void* (*PRESTypePluginDefaultEndpointDataCreateSampleFunction) (void);

typedef void* (*PRESTypePluginDefaultEndpointDataCreateKeyFunction) (void);

typedef void (*PRESTypePluginDefaultEndpointDataDestroySampleFunction) (void *sample);

typedef void (*PRESTypePluginDefaultEndpointDataDestroyKeyFunction) (void *key);

typedef unsigned int (*PRESTypePluginGetSerializedSampleSizeFunction) (
    PRESTypePluginEndpointData endpointData,
    RTIBool includeEncapsulation,
    RTIEncapsulationId encapsulationId,
    unsigned int size,
    const void * sample);

typedef unsigned int (*PRESTypePluginGetSerializedSampleMaxSizeFunction)
    (PRESTypePluginEndpointData endpointData,
     RTIBool includeEncapsulation,
     RTIEncapsulationId encapsulationId,
     unsigned int size);

extern PRESDllExport PRESTypePluginEndpointData
PRESTypePluginDefaultEndpointData_new(
    PRESTypePluginParticipantData participantData,
    const struct PRESTypePluginEndpointInfo *endpointInfo,
    PRESTypePluginDefaultEndpointDataCreateSampleFunction createSampleFnc,
    PRESTypePluginDefaultEndpointDataDestroySampleFunction deleteSampleFnc,
    PRESTypePluginDefaultEndpointDataCreateKeyFunction createKeyFnc,
    PRESTypePluginDefaultEndpointDataDestroyKeyFunction deleteKeyFnc);

extern PRESDllExport PRESTypePluginEndpointData
PRESTypePluginDefaultEndpointData_newWithNotification(
    PRESTypePluginParticipantData participantData,
    const struct PRESTypePluginEndpointInfo *endpointInfo,
    REDAFastBufferPoolBufferInitializeFunction createSampleFnc,
    void* createSampleParam,
    REDAFastBufferPoolBufferFinalizeFunction deleteSampleFnc,
    void* deleteSampleParam,
    REDAFastBufferPoolBufferInitializeFunction createKeyFnc,
    void* createKeyParam,
    REDAFastBufferPoolBufferFinalizeFunction deleteKeyFnc,
    void* deleteKeyParam);

extern PRESDllExport void
PRESTypePluginDefaultEndpointData_delete(
    PRESTypePluginEndpointData endpointData);

extern PRESDllExport PRESTypePluginParticipantData
PRESTypePluginDefaultParticipantData_new(
    const struct PRESTypePluginParticipantInfo *participantInfo);

extern PRESDllExport void
PRESTypePluginDefaultParticipantData_delete(
    PRESTypePluginParticipantData participantData);

extern PRESDllExport void *
PRESTypePluginDefaultEndpointData_getSample(
    PRESTypePluginEndpointData endpointData,
    void **handle /* out */);

extern PRESDllExport void
PRESTypePluginDefaultEndpointData_returnSample(
    PRESTypePluginEndpointData endpointData,
    void *sample, void *handle);

extern PRESDllExport void *
PRESTypePluginDefaultEndpointData_getFlatSample(
    PRESTypePluginEndpointData endpointData);

extern PRESDllExport void
PRESTypePluginDefaultEndpointData_returnFlatSample(
    PRESTypePluginEndpointData endpointData,
    void *sample);

extern PRESDllExport void *
PRESTypePluginDefaultEndpointData_createSample(
    PRESTypePluginEndpointData endpointData);

extern PRESDllExport void
PRESTypePluginDefaultEndpointData_deleteSample(
    PRESTypePluginEndpointData endpointData,
    void *sample);

extern PRESDllExport void *
PRESTypePluginDefaultEndpointData_getKey(
    PRESTypePluginEndpointData endpointData,
    void **handle /* out */);

extern PRESDllExport void
PRESTypePluginDefaultEndpointData_returnKey(
    PRESTypePluginEndpointData endpointData,
    void *key, void *handle);

extern PRESDllExport void *
PRESTypePluginDefaultEndpointData_createKey(
    PRESTypePluginEndpointData endpointData);

extern PRESDllExport void
PRESTypePluginDefaultEndpointData_deleteKey(
    PRESTypePluginEndpointData endpointData,
    void *key);

extern PRESDllExport int
PRESTypePluginDefaultEndpointData_getEncapsulationPoolThreshold(
    PRESTypePluginEndpointData endpointData,
    RTIEncapsulationId encapsulationId);

extern PRESDllExport RTIBool
PRESTypePluginDefaultEndpointData_getBuffer(
    PRESTypePluginEndpointData endpoint_plugin_data,
    struct REDABuffer *buffer,               /* Buffer to return ptr + length */
    RTIEncapsulationId encapsulationId,
    const void * user_data);                 /* Can be NULL for batch */

extern PRESDllExport RTIBool
PRESTypePluginDefaultEndpointData_getPreallocatedBuffer(
    PRESTypePluginEndpointData endpoint_plugin_data,
    struct REDABuffer *buffer,
    RTIEncapsulationId encapsulationId);

extern PRESDllExport void 
PRESTypePluginDefaultEndpointData_returnBuffer(
    PRESTypePluginEndpointData endpoint_plugin_data,
    struct REDABuffer *buffer, /* Buffer to release */
    RTIEncapsulationId encapsulationId);

extern PRESDllExport void
PRESTypePluginDefaultEndpointData_returnPreallocatedBuffer(
        PRESTypePluginEndpointData endpointData,
        struct REDABuffer *buffer,
        RTIEncapsulationId encapsulationId);

extern PRESDllExport RTIBool
PRESTypePluginDefaultEndpointData_createMD5Stream(
        PRESTypePluginEndpointData endpointData,
        RTI_UINT32 serializedKeyMaxSizeV1,
        RTI_UINT32 serializedKeyMaxSizeV2);

extern PRESDllExport RTIBool
PRESTypePluginDefaultEndpointData_createMD5StreamWithInfo(
        PRESTypePluginEndpointData endpointData,
        const struct PRESTypePluginEndpointInfo *endpointInfo,
        RTI_UINT32 serializedKeyMaxSizeV1,
        RTI_UINT32 serializedKeyMaxSizeV2);

extern PRESDllExport struct RTICdrStream *
PRESTypePluginDefaultEndpointData_getMD5Stream(
    PRESTypePluginEndpointData endpointData);

extern PRESDllExport unsigned int
PRESTypePluginDefaultEndpointData_getMaxSizeSerializedKey(
    PRESTypePluginEndpointData endpointData,
    RTIBool v2);

extern PRESDllExport unsigned int
PRESTypePluginDefaultEndpointData_getMaxSizeSerializedSample(
    PRESTypePluginEndpointData endpointData);

extern PRESDllExport unsigned int
PRESTypePluginDefaultEndpointData_getTempSample(
    PRESTypePluginEndpointData endpointData);

extern PRESDllExport void
PRESTypePluginDefaultEndpointData_setBaseAlignment(
    PRESTypePluginEndpointData endpointData,
    unsigned int alignment);

extern PRESDllExport unsigned int
PRESTypePluginDefaultEndpointData_getAlignment(
    PRESTypePluginEndpointData endpointData,
    int currentSize);

extern PRESDllExport RTIBool 
PRESTypePluginDefaultEndpointData_createWriterPool(
    PRESTypePluginEndpointData endpointPluginData,
    const struct PRESTypePluginEndpointInfo *endpointInfo,
    PRESTypePluginGetSerializedSampleMaxSizeFunction getSerializedSampleMaxSizeFnc,
    PRESTypePluginEndpointData getSerializedSampleMaxSizeFncArg,
    PRESTypePluginGetSerializedSampleSizeFunction getSerializedSampleSizeFnc,
    PRESTypePluginEndpointData getSerializedSampleSizeFncArg
);

extern PRESDllExport struct RTIXCdrInterpreterPrograms *
PRESTypePluginDefaultEndpointData_getPrograms(
    PRESTypePluginEndpointData endpointData);

extern PRESDllExport void
PRESTypePluginDefaultEndpointData_setPrograms(
    PRESTypePluginEndpointData endpointData,
    struct RTIXCdrInterpreterPrograms *programs);

extern PRESDllExport RTIBool
PRESTypePluginDefaultEndpointData_isCompressionEnabled(
    PRESTypePluginEndpointData endpointData);

extern PRESDllExport void*
PRESTypePluginDefaultEndpointData_getWriterLoanedSample(
    PRESTypePluginEndpointData endpointData,
    const struct REDAFastBufferPoolGrowthProperty *sampleAllocation);

extern PRESDllExport void
PRESTypePluginDefaultEndpointData_returnWriterLoanedSample(
    PRESTypePluginEndpointData endpointData,
    const void *sample);

extern PRESDllExport void
PRESTypePluginDefaultEndpointData_returnWriterLoanedSampleFromCookie(
    PRESTypePluginEndpointData endpointData,
    const struct REDABuffer *cookie);

extern PRESDllExport RTIBool
PRESTypePluginDefaultEndpointData_validateWriterLoanedSample(
    PRESTypePluginEndpointData endpointData,
    const void *sample,
    RTIBool isDiscard);

extern PRESDllExport void
PRESTypePluginDefaultEndpointData_setWriterLoanedSampleSerializedState(
    PRESTypePluginEndpointData endpointData,
    const void *sample);



/*
 * This represents the old concept of threshold to determine whether to get
 * the buffer from a fast buffer or from the heap.
 * Possible values:
 * -1: use only fast buffer pool (default), and use serializedSampleMaxSize() for pool size
 * 0 : use only heap
 * any positive number: use this value as threshold to decide
 *
 * Advanced: It is possible as well to provide a threshold per encapsulation
 * using this format:
 *
 * sprintf(propertyValue, "(%s, %d)", encapsulationString, threshold);
 *
 * where encapsulationString is the stringified version of a
 * DDS_EncapsulationId_t, with or without the leading "DDS_".
 *
 * The only possible "DDS_" values are "DDS_ENCAPSULATION_ID_CDR_BE",
 * "DDS_ENCAPSULATION_ID_CDR_LE", "DDS_ENCAPSULATION_ID_CDR_NATIVE",
 * "DDS_ENCAPSULATION_ID_CDR2_BE", "DDS_ENCAPSULATION_ID_CDR2_LE", and
 * "DDS_ENCAPSULATION_ID_CDR2_NATIVE" because PL and D are handled at the type
 * plugin level.
 */
#define NDDS_DWHISTORY_MEMORYMANAGER_FASTPOOL_POOLBUFFERMAXSIZE PROPERTY_NAME_DDS_DATA_WRITER_HISTORY_MEMORY_MANAGER_FAST_POOL_POOL_BUFFER_MAX_SIZE

/* This represent the old concept of threshold to determine whether to get
 * the buffer from a fast buffer or from the heap. 
 * In the case of a DataReader this buffer is used to allocate the keys
 * serialization buffers 
 *
 * See NDDS_DWHISTORY_MEMORYMANAGER_FASTPOOL_POOLBUFFERMAXSIZE for the format
 * for specifying a threshold per encapsulation.
 */
#define NDDS_DRHISTORY_MEMORYMANAGER_FASTPOOL_POOLBUFFERMAXSIZE \
    PROPERTY_NAME_DDS_DATA_READER_HISTORY_MEMORY_MANAGER_FAST_POOL_POOL_BUFFER_MAX_SIZE

/* Determines when to GET a serialization buffer.
 * get_mode values:
 *      IMMEDIATE - serialization buffer is obtained when the sample is inserted into the queue
        LAZY - buffer is obtained only when sample must be sent to destination 
 * 
 * Possible values:
 * (encapsulation id_1, buffer_get_mode_1), ... (encapsulation_id_N, buffer_get_mode_N)
 * <unset>: IMMEDIATE for all unset encapsulations
 */
#define NDDS_DWHISTORY_MEMORYMANAGER_FASTPOOL_BUFFERGETMODE PROPERTY_NAME_DDS_DATA_WRITER_HISTORY_MEMORY_MANAGER_FAST_POOL_BUFFER_GET_MODE

/* Determines when to RETURN a serialization buffer.
 * return_mode values:
 *      IMMEDIATE - buffer is returned immediately after sample is sent over the wire
        LAZY - buffer is returned when sample is removed from the writer queue
 * 
 * Possible values:
 * (encapsulation id_1, buffer_return_mode_1), ... (encapsulation_id_N, buffer_return_mode_N)
 * <unset>: LAZY for all unset encapsulations
 */
#define NDDS_DWHISTORY_MEMORYMANAGER_FASTPOOL_BUFFERRETURNMODE PROPERTY_NAME_DDS_DATA_WRITER_HISTORY_MEMORY_MANAGER_FAST_POOL_BUFFER_RETURN_MODE

/* Indicates whether serialization buffer must be obtained
 */
#define NDDS_DWHISTORY_MEMORYMANAGER_FASTPOOL_ZEROCOPY PROPERTY_NAME_DDS_DATA_WRITER_HISTORY_MEMORY_MANAGER_FAST_POOL_ZERO_COPY

typedef PRESTypePluginParticipantData (*PRESTypePluginOnParticipantAttachedCallback)
    (void *registrationData, const struct PRESTypePluginParticipantInfo *participantInfo,
     RTIBool topLevelRegistration, void *containerPluginContext,
     RTICdrTypeCode *typeCode);

typedef void (*PRESTypePluginOnParticipantDetachedCallback)
    (PRESTypePluginParticipantData participantData);

typedef PRESTypePluginEndpointData (*PRESTypePluginOnEndpointAttachedCallback)
    (PRESTypePluginParticipantData participantData,
     const struct PRESTypePluginEndpointInfo *endpointInfo,
     RTIBool topLevelRegistration, void *containerPluginContext);

typedef void (*PRESTypePluginOnEndpointDetachedCallback)
    (PRESTypePluginEndpointData endpointData);

typedef RTIBool (*PRESTypePluginCopySampleFunction)
    (PRESTypePluginEndpointData endpointData, void *dst, const void *src);

typedef void* (*PRESTypePluginCreateSampleFunction)
    (PRESTypePluginEndpointData endpointData);

typedef void (*PRESTypePluginDestroySampleFunction)
    (PRESTypePluginEndpointData endpointData,
     void *sample);

typedef void (*PRESTypePluginFinalizeOptionalMembersFunction)(
        PRESTypePluginEndpointData endpointData,
        void *sample,
        RTIBool deletePointers);

typedef unsigned int (*PRESTypePluginGetDeserializedSampleMaxSizeFunction)
    (PRESTypePluginEndpointData endpointData);

typedef RTIBool (*PRESTypePluginInstanceToKeyHashFunction)
    (PRESTypePluginEndpointData endpointData,
     struct MIGRtpsKeyHash *keyHash,
     const void *sample,
     RTIEncapsulationId encapsulationId);

typedef RTIBool (*PRESTypePluginSerializedSampleToKeyHashFunction)
    (PRESTypePluginEndpointData endpointData,
     struct RTICdrStream *stream, 
     struct MIGRtpsKeyHash *keyHash,
     RTIBool deserializeEncapsulation, 
     void *endpointPluginQos);

typedef RTIBool (*PRESTypePluginSerializedKeyToKeyHashFunction)
    (PRESTypePluginEndpointData endpointData,
     struct RTICdrStream *stream, 
     struct MIGRtpsKeyHash *keyHash,
     RTIBool deserializeEncapsulation, 
     void *endpointPluginQos);

typedef RTIBool (*PRESTypePluginSerializeFunction)
    (PRESTypePluginEndpointData endpoint_plugin_data,
     const void *sample, struct RTICdrStream *stream, 
     RTIBool serializeEncapsulation,
     RTIEncapsulationId encapsulationId,
     RTIBool serializeSample, 
     void *endpointPluginQos);

typedef RTIBool (*PRESTypePluginDeserializeFunction)
    (PRESTypePluginEndpointData endpointData,
     void ** sample, RTIBool * dropSample,
     struct RTICdrStream *stream,
     RTIBool deserializeEncapsulation, 
     RTIBool deserializeSample, 
     void *endpointPluginQos);

typedef RTIBool (*PRESTypePluginSerializeKeyFunction)
    (PRESTypePluginEndpointData endpointData,
     const void *key, struct RTICdrStream *stream, 
     RTIBool serializeEncapsulation, 
     RTIEncapsulationId encapsulationId,
     RTIBool serializeKey, 
     void *endpointPluginQos);

typedef RTIBool (*PRESTypePluginDeserializeKeySampleFunction)
    (PRESTypePluginEndpointData endpointData,
     void * key,
     struct RTICdrStream *stream, 
     RTIBool deserializeEncapsulation, 
     RTIBool deserializeKey, 
     void *endpointPluginQos);

typedef RTIBool (*PRESTypePluginDeserializeKeyFunction)
    (PRESTypePluginEndpointData endpointData,
     void ** key, RTIBool * dropKey,
     struct RTICdrStream *stream, 
     RTIBool deserializeEncapsulation, 
     RTIBool deserializeKey, 
     void *endpointPluginQos);

typedef void* (*PRESTypePluginGetKeyFunction) 
    (PRESTypePluginEndpointData endpointData, void** handle);

typedef void (*PRESTypePluginReturnKeyFunction)
    (PRESTypePluginEndpointData endpointData, void *key, void* handle);

  
    /*e \ingroup PRESTypePluginDataPoolModule
     * Sometimes the reader's pool of pointers to samples is replaced by a
     * pool of pointers that have been initialized to the
     * INVALID_SAMPLE_ADDRESS. This is used to indicate that the typeplugin
     * must get a sample from a separate pool during deserialization.
     * 
     * This happens with the context of DynamicData, FlatData and ZeroCopy
     * typeplugins.
     */
    #define PRES_TYPE_PLUGIN_INVALID_SAMPLE_ADDRESS 0x1

    /*e \ingroup PRESTypePluginDataPoolModule
     *
     * When a reader's pool of pointers to samples is initialized to
     * PRES_TYPE_PLUGIN_INVALID_SAMPLE_ADDRESS and we receive a re assembled
     * sample. Then we update the sample's initialized value from
     * PRES_TYPE_PLUGIN_INVALID_SAMPLE_ADDRESS to
     * PRES_TYPE_PLUGIN_INVALID_REASSEMBLED_SAMPLE_ADDRESS. This information is
     * needed for returning the sample to the fst pool.
     * This happens with the context of DynamicData, FlatData and ZeroCopy
     * typeplugins.
     */
    #define PRES_TYPE_PLUGIN_INVALID_REASSEMBLED_SAMPLE_ADDRESS 0x2

    /*e \ingroup PRESTypePluginDataPoolModule 
     * 
     * When using a local data writer to add samples directly to the reader's
     * queue, the handle in the getSampleFnc can be set to this value to
     * indicate that the getSampleFnc must return a copyable object. Otherwise,
     * some type plugin implementations (flat data, dynamic data,
     * and zero copy) just return sentinel values as opposed to actual sample
     * objects
     */
    #define PRES_TYPE_PLUGIN_LOCAL_DATA_SAMPLE_ADDRESS 0x3

typedef void* (*PRESTypePluginGetSampleFunction)
    (PRESTypePluginEndpointData endpointData, void** handle);

typedef void (*PRESTypePluginReturnSampleFunction)
    (PRESTypePluginEndpointData endpointData, void *sample, void* handle);

typedef unsigned int (*PRESTypePluginGetSerializedSampleMinSizeFunction)
    (PRESTypePluginEndpointData endpointData,
     RTIBool includeEncapsulation,
     RTIEncapsulationId encapsulationId,
     unsigned int size);

typedef unsigned int (*PRESTypePluginGetSerializedKeyMaxSizeFunction)
    (PRESTypePluginEndpointData endpointData,
     RTIBool includeEncapsulation,
     RTIEncapsulationId encapsulation_id,
     unsigned int size);

typedef RTIBool (*PRESTypePluginInstanceToKeyFunction)
    (PRESTypePluginEndpointData endpointData,
     void *key, const void *instance);

typedef RTIBool (*PRESTypePluginKeyToInstanceFunction)
    (PRESTypePluginEndpointData endpoint_plugin_data,
     void *instance, const void *key);

typedef PRESTypePluginKeyKind (*PRESTypePluginGetKeyKindFunction) (void);

typedef RTIBool (*PRESTypePluginGetBufferFunction)(
    PRESTypePluginEndpointData endpoint_plugin_data,
    struct REDABuffer *buffer,              /* Buffer to return ptr + length */
    RTIEncapsulationId encapsulationId,
    const void * user_data);                /* Can be NULL for batch */

typedef void (*PRESTypePluginReturnBufferFunction)(
    PRESTypePluginEndpointData endpoint_plugin_data,
    struct REDABuffer *buffer,             /* Buffer to release */
    RTIEncapsulationId encapsulationId);

typedef void* (*PRESTypePluginGetWriterLoanedSampleFunction)(
    PRESTypePluginEndpointData endpoint_plugin_data,
    const struct REDAFastBufferPoolGrowthProperty *sampleAllocation);

typedef void (*PRESTypePluginReturnWriterLoanedSampleFunction)(
    PRESTypePluginEndpointData endpoint_plugin_data,
    const void *sample);

typedef void (*PRESTypePluginReturnWriterLoanedSampleFromCookieFunction)(
    PRESTypePluginEndpointData endpoint_plugin_data,
    const struct REDABuffer *cookie);

typedef RTIBool (*PRESTypePluginValidateWriterLoanedSampleFunction)(
    PRESTypePluginEndpointData endpoint_plugin_data,
    const void *sample,
    RTIBool isDiscard);

typedef void (*PRESTypePluginSetWriterLoanedSampleSerializedStateFunction)(
    PRESTypePluginEndpointData endpoint_plugin_data,
    const void *sample);

struct PRESTypePluginBufferPoolMgmtCfg {
    int poolBufferMaxSize;
    int dynamicMemoryMaxSize;
};

struct PRESTypePluginPool {

    int encapsulationCount;
    RTIEncapsulationId *encapsulations; /* array */

    struct REDAFastBufferPool *samplePool;

    /* Samples from writerLoanedSamplePool are managed via the two lists
     * inUseWriterLoanedSamples and freeWriterLoanedSamples.
     *
     * freeWriterLoanedSamples contains samples which are discarded(discardLoan)
     *     or removed via on_sample_removed callback.
     * inUseWriterLoanedSamples contains samples which are are returned by
     *     getLoan operation
     *
     * During TypePlugin pool deletion, samples from both these lists are
     * returned back to the pool before deleting the lists and the pool
     * */
    struct REDAFastBufferPool *writerLoanedSamplePool;
    struct REDAInlineList *inUseWriterLoanedSamples;
    struct REDAInlineList *freeWriterLoanedSamples;
    unsigned int _writerLoanedSampleMaxSize;
    struct RTIOsapiSemaphore *_loanedSamplesMutex;

    struct REDAFastBufferPool *keyPool;
    struct PRESTypePluginEndpointInfo endpointInfo;

    /*
     * One ThresholdBufferPool per encapsulation.
     * These pools provide buffers for the serialized samples and any
     * transformation such as security or compression..
     */
    struct REDAThresholdBufferPool **bufferPool;

    /*
     * Array containing the size of the preallocated buffers, one size per
     * encapsulation.
     */
    int *bufferPoolThreshold;

    /*
     * Array containing if for the given encapsulation the dynamic memory
     * allocation is enabled. If the threshold is equal or larger to the maximun
     * serialized sample size, we don't need dynamic memory allocation, so we
     * disable it.
     */
    RTIBool *dynamicMemoryAllocationEnabled;

    /* Indicates when batching is enable for all the encapsulations. */
    RTIBool batchEnabled;

    PRESTypePluginDefaultEndpointDataCreateSampleFunction 
        createSampleFnc;
    PRESTypePluginDefaultEndpointDataDestroySampleFunction 
        deleteSampleFnc;

    PRESTypePluginDefaultEndpointDataCreateKeyFunction 
        createKeyFnc;
    PRESTypePluginDefaultEndpointDataDestroyKeyFunction 
        deleteKeyFnc;
    PRESTypePluginGetSerializedSampleSizeFunction
        getSerializedSampleSizeFnc;
    /* Argument to pass to getSerializedSampleSizeFnc as endpointData */
    PRESTypePluginParticipantData getSerializedSampleSizeFncArg;

    /* initialize and destroy sample with parameter */
    REDAFastBufferPoolBufferInitializeFunction createSampleWithParamFnc;
    void* createSampleParam;
    REDAFastBufferPoolBufferFinalizeFunction deleteSampleWithParamFnc;
    void* deleteSampleParam;

    REDAFastBufferPoolBufferInitializeFunction createKeyWithParamFnc;
    void* createKeyParam;
    REDAFastBufferPoolBufferFinalizeFunction deleteKeyWithParamFnc;
    void* deleteKeyParam;
};


struct PRESTypePluginVersion {
    char majorRev;
    char minorRev;
    char majorOptions;
    char minorOptions;
};

/* plugin version copied from nddsgen module version */

/* CURRENT VERSION: 2.0 */
#define PRES_TYPE_PLUGIN_VERSION_1_0  {1, 0, 0, 0}
#define PRES_TYPE_PLUGIN_VERSION_1_1  {1, 1, 0, 0}
#define PRES_TYPE_PLUGIN_VERSION_2_0  {2, 0, 0, 0}
#define PRES_TYPE_PLUGIN_VERSION_CURRENT  PRES_TYPE_PLUGIN_VERSION_2_0


struct PRESTypePlugin {
    /* Callbacks */
    PRESTypePluginOnParticipantAttachedCallback
        onParticipantAttached;
    PRESTypePluginOnParticipantDetachedCallback
        onParticipantDetached;
    PRESTypePluginOnEndpointAttachedCallback
        onEndpointAttached;
    PRESTypePluginOnEndpointDetachedCallback
        onEndpointDetached;

    /* Sample manipulation */
    PRESTypePluginCopySampleFunction
        copySampleFnc;
    PRESTypePluginCreateSampleFunction
        createSampleFnc;
    PRESTypePluginDestroySampleFunction
        destroySampleFnc;
    PRESTypePluginFinalizeOptionalMembersFunction
        finalizeOptionalMembersFnc;

    /* Compute key hash */
    PRESTypePluginInstanceToKeyHashFunction
        instanceToKeyHashFnc;
    PRESTypePluginSerializedSampleToKeyHashFunction
        serializedSampleToKeyHashFnc;

    /* Serialize */
    PRESTypePluginSerializeFunction
        serializeFnc;
    
    /* Deserialize */
    PRESTypePluginDeserializeFunction
        deserializeFnc;

    /* Sample */
    PRESTypePluginGetSampleFunction
        getSampleFnc;
    PRESTypePluginReturnSampleFunction
        returnSampleFnc;

    /* Sizing */
    PRESTypePluginGetSerializedSampleMaxSizeFunction
        getSerializedSampleMaxSizeFnc;
    PRESTypePluginGetSerializedSampleMinSizeFunction
        getSerializedSampleMinSizeFnc;

    PRESTypePluginGetSerializedSampleSizeFunction
        getSerializedSampleSizeFnc;

    PRESTypePluginGetDeserializedSampleMaxSizeFunction
        getDeserializedSampleMaxSizeFnc;

    /* Key kind */
    PRESTypePluginGetKeyKindFunction
        getKeyKindFnc;

    /**********************************************
    **** Functions only needed for keyed types ****
    **********************************************/

    /* Keys */
    PRESTypePluginGetKeyFunction
        getKeyFnc;
    PRESTypePluginReturnKeyFunction
        returnKeyFnc;

    /* Sizing */
    PRESTypePluginGetSerializedKeyMaxSizeFunction
        getSerializedKeyMaxSizeFnc;

    /* Instance <=> Key */
    PRESTypePluginInstanceToKeyFunction
        instanceToKeyFnc;
    PRESTypePluginKeyToInstanceFunction
        keyToInstanceFnc;

    /* Key (de)serialize */
    PRESTypePluginSerializeKeyFunction
        serializeKeyFnc;
    PRESTypePluginDeserializeKeyFunction
        deserializeKeyFnc;
    PRESTypePluginDeserializeKeySampleFunction
        deserializeKeySampleFnc;

    PRESTypePluginSerializedKeyToKeyHashFunction
        serializedKeyToKeyHashFnc;
    
    /*e 
     *Type Code associated to the type. This is the type that is sent 
     *  during discovery, so it should be the original type that the user
     *  registered with the Participant, not an optimized/altered version. Any
     *  alternate version of a type should be stored in the optimizedTypeCode
     *  field below.
     */
    struct RTICdrTypeCode *typeCode;

    /*e 
     * An alternate version of the typeCode.
     * 
     * This field is currently only used by the DynamicData type plugin.
     * The DynamicData type plugin operates over a version of the type that has
     * had all pointers and typedefs stripped out of it. This is done for
     * efficiency while processing the type. 
     */
    struct RTICdrTypeCode *alternateTypeCode;

    /*i Opaque buffer for storing user data */
    PRESWord* _userBuffer;
    /*e Plugin kind */
    PRESTypePluginLanguageKind languageKind;
    /*i Version */
    struct PRESTypePluginVersion version;
    
    /*e Buffer allocator for serialization */
    
    /*e Allocator for the serialized buffer */
    PRESTypePluginGetBufferFunction getBuffer;
    NDDS_WriterHistory_Allocator_getBufferWithParams_fn getBufferWithParams;
    
    /*e Return buffer allocated by getBuffer */
    PRESTypePluginReturnBufferFunction returnBuffer;
    NDDS_WriterHistory_Allocator_returnBufferWithParams_fn returnBufferWithParams;

    /* Functions needed to support writer loaned samples */
    PRESTypePluginGetWriterLoanedSampleFunction getWriterLoanedSampleFnc;
    PRESTypePluginReturnWriterLoanedSampleFunction returnWriterLoanedSampleFnc;
    PRESTypePluginReturnWriterLoanedSampleFromCookieFunction
        returnWriterLoanedSampleFromCookieFnc;
    PRESTypePluginValidateWriterLoanedSampleFunction
        validateWriterLoanedSampleFnc;
    PRESTypePluginSetWriterLoanedSampleSerializedStateFunction
        setWriterLoanedSampleSerializedStateFnc;

    /*i Unique type name */
    const char *endpointTypeName;

    /*i type code name */
    const char *typeCodeName;
    
    /* This pointer is reserved for the middleware */
    void * reserved;

    /* Set to true in generated code if metp code is generated for
     * this type */
    RTIBool isMetpType;
};


#define PRES_TYPEPLUGIN_DEFAULT {                   \
NULL, /* onParticipantAttached */                   \
NULL, /* onParticipantDetached */                   \
NULL, /* onEndpointAttached */                      \
NULL, /* onEndpointDetached */                      \
NULL, /* copySample */                              \
NULL, /* createSample */                            \
NULL, /* destroySample */                           \
NULL, /* finalizeOptionalMembersFnc */              \
NULL, /* instanceToKeyHash */                       \
NULL, /* serializedSampleToKeyHash */               \
NULL, /* serialize */                               \
NULL, /* deserialize */                             \
NULL, /* getSample */                               \
NULL, /* returnSample */                            \
NULL, /* getSerializedSampleMaxSize */              \
NULL, /* getSerializedSampleMinSize */              \
NULL, /* getSerializedSampleSize */                 \
NULL, /* getDeserializedSampleMaxSizeFnc */         \
NULL, /* getKeyKind */                              \
NULL, /* getKey */                                  \
NULL, /* returnKey */                               \
NULL, /* getSerializedKeyMaxSize */                 \
NULL, /* instanceToKey */                           \
NULL, /* keyToInstance */                           \
NULL, /* serializeKey */                            \
NULL, /* deserializeKey */                          \
NULL, /* deserializeKeySample */                    \
NULL, /* serializedKeyToKeyHash */                  \
NULL, /* typeCode */                                \
NULL, /* cftTypeCode */                             \
NULL, /* userBuffer */                              \
PRES_TYPEPLUGIN_UNKNOWN_LANG, /* languageKind */    \
PRES_TYPE_PLUGIN_VERSION_CURRENT, /* version */     \
NULL, /* getBuffer */                               \
NULL, /* getBufferWithParams */                     \
NULL, /* returnBuffer */                            \
NULL, /* returnBufferWithParams */                  \
NULL, /* getWriterLoanedSampleFnc */                \
NULL, /* returnWriterLoanedSampleFnc */             \
NULL, /* returnWriterLoanedSampleFromCookieFnc */   \
NULL, /* validateWriterLoanedSampleFnc */           \
NULL, /* setWriterLoanedSampleSerializedStateFnc */ \
NULL, /* endpointTypeName */                        \
NULL, /* typeCodeName */                            \
NULL,  /* reserved */                               \
RTI_FALSE /* isMetpType */                          \
}

/*i \ingroup PRESTypePluginModule
  Parameter alignment.
*/
#define PRES_TYPEPLUGIN_PARAMETER_ALIGNMENT (4)

extern PRESDllExport 
PRESWord *PRESTypePlugin_getUserData(const struct PRESTypePlugin *self);

extern PRESDllExport 
void PRESTypePlugin_setUserData(
        struct PRESTypePlugin *self, 
        PRESWord *userData);

extern PRESDllExport const char *
PRESTypePlugin_getEndpointTypeName(const struct PRESTypePlugin *self);

extern PRESDllExport 
void PRESTypePlugin_copy(
	struct PRESTypePlugin *dst, 
	const struct PRESTypePlugin *src);

extern PRESDllExport
RTIBool PRESTypePlugin_serializePrimitiveParameter(
    struct RTICdrStream *stream, const void *in,
    RTICdrPrimitiveType type,
    RTICdrUnsignedShort parameterId);

extern PRESDllExport
RTIBool PRESTypePlugin_serializeNonPrimitiveParameter(
    struct RTICdrStream *stream, const void *in,
    RTICdrStreamSerializeFunction serializeFunction,
    RTICdrUnsignedShort parameterId,
    RTIBool serializeEncapsulation, RTIEncapsulationId encapsulationId,
    RTIBool serializeSample,
    PRESTypePluginEndpointData endpointData, void* endpointPluginQos);

extern PRESDllExport
RTIBool PRESTypePlugin_serializeNonPrimitiveParameterExtended(
    struct RTICdrStream *stream, const void *in,
    RTICdrStreamSerializeFunction serializeFunction,
    RTICdrUnsignedLong parameterId,
    RTIBool serializeEncapsulation, RTIEncapsulationId encapsulationId,
    RTIBool serializeSample,
    PRESTypePluginEndpointData endpointData, void* endpointPluginQos);

extern PRESDllExport
RTIBool PRESTypePlugin_serializePrimitiveArrayParameter(
    struct RTICdrStream *stream, const void *in,
    RTICdrUnsignedLong length,
    RTICdrPrimitiveType type, RTICdrUnsignedShort parameterId);

/*i \ingroup PRESTypePluginModule
  Helper method for serializing array of non-primitive type parameter in
  parameter sequence.

  @param stream \b InOut. Stream used for serialization.
  @param in \b In. non-primitive type that is used as in the array of parameter.
  @param length \b In. Length of array.
  @param serializefunction \b In. Function used for serialization.
  @param parameterId \b In. ID used for parameter.
  @param serializeOption \b In. serialize option obtained from writer property.

  @return RTI_TRUE if successful. RTI_FALSE otherwise.
*/
extern PRESDllExport
RTIBool PRESTypePlugin_serializeNonPrimitiveArrayParameter(
    struct RTICdrStream *stream, const void *in,
    RTICdrUnsignedLong length, unsigned int elementSize,
    RTICdrStreamSerializeFunction serializeFunction,
    RTICdrUnsignedShort parameterId,
    RTIBool serializeEncapsulation, RTIEncapsulationId encapsulationId,
    RTIBool serializeSample,
    PRESTypePluginEndpointData endpointData, void* endpointPluginQos);

extern PRESDllExport
RTIBool PRESTypePlugin_serializePrimitiveSequenceParameter(
    struct RTICdrStream *stream, const void *in,
    RTICdrUnsignedLong length, RTICdrUnsignedLong maximumLength,
    RTICdrPrimitiveType type, RTICdrUnsignedShort parameterId);

extern PRESDllExport
RTIBool PRESTypePlugin_serializeNonPrimitiveSequenceParameter(
    struct RTICdrStream *stream, const void *in,
    RTICdrUnsignedLong length, RTICdrUnsignedLong maximumLength,
    unsigned int elementSize,
    RTICdrStreamSerializeFunction serializeFunction,
    RTICdrUnsignedShort parameterId,
    RTIBool serializeEncapsulation, RTIEncapsulationId encapsulationId,
    RTIBool serializeSample,
    PRESTypePluginEndpointData endpointData, void* endpointPluginQos);

extern PRESDllExport
RTIBool PRESTypePlugin_serializeStringParameter(
    struct RTICdrStream *stream, const char *in,
    RTICdrUnsignedLong maximumLength,
    RTICdrUnsignedShort parameterId);

extern PRESDllExport
RTIBool PRESTypePlugin_serializeWstringParameter(
    struct RTICdrStream *stream, const RTICdrWchar *in,
    RTICdrUnsignedLong length, RTICdrUnsignedLong maximumLength,
    RTICdrUnsignedShort parameterId);

extern PRESDllExport
RTIBool PRESTypePlugin_serializeParameterSequenceEnd(
    struct RTICdrStream *stream);

typedef RTIBool (*PRESTypePluginDeserializeParameterValueFunction)
    (PRESTypePluginEndpointData endpointData, 
     RTIBool *ok, void *parameters, struct RTICdrStream *stream,
     unsigned long parameterId, unsigned long parameterLength,
     RTIBool deserializeEncapsulation, RTIBool deserializeSample,
     void* endpointPluginQos);

typedef void (*PRESTypePluginSetDefaultParameterValuesFunction) (
        void *parameter,
        const struct MIGInterpreterContext *rtpsContext);

extern PRESDllExport RTIBool PRESTypePlugin_serializeParameterSequence(
    struct RTICdrStream *stream, const void *parameters,
    RTICdrStreamSerializeFunction serializeParametersFunction,
    RTIBool serializeEncapsulation, 
    RTIEncapsulationId encapsulationId,
    RTIBool serializeSample,
    PRESTypePluginEndpointData endpointData, void* endpointPluginQos);

extern PRESDllExport RTIBool PRESTypePlugin_deserializeParameterSequence(
    void *parameter, struct RTICdrStream *stream,
    PRESTypePluginSetDefaultParameterValuesFunction
    setDefaultParameterValuesFnc,
    PRESTypePluginDeserializeParameterValueFunction
    deserializeParameterValueFnc,
    RTIBool deserializeEncapsulation, RTIBool deserializeSample,
    PRESTypePluginEndpointData endpointData, void* endpointPluginQos);

extern PRESDllExport
unsigned int PRESTypePlugin_getParameterHeaderMaxSizeSerialized(
    unsigned int size);

extern PRESDllExport
RTIBool PRESTypePlugin_interpretedSerialize(
        PRESTypePluginEndpointData endpointData,
        const void *sample, 
        struct RTICdrStream *stream,    
        RTIBool serializeEncapsulation,
        RTIEncapsulationId encapsulationId,
        RTIBool serializeSample, 
        void *endpointPluginQos);

extern PRESDllExport
RTIBool PRESTypePlugin_interpretedSerializeKey(
        PRESTypePluginEndpointData endpointData,
        const void *sample, 
        struct RTICdrStream *stream,    
        RTIBool serializeEncapsulation,
        RTIEncapsulationId encapsulationId,
        RTIBool serializeKey,
        void *endpointPluginQos);

extern PRESDllExport
RTIBool PRESTypePlugin_interpretedDeserialize(
        PRESTypePluginEndpointData endpointData,
        void *sample,
        struct RTICdrStream *stream,   
        RTIBool deserializeEncapsulation,
        RTIBool deserializeSample, 
        void *endpointPluginQos);

extern PRESDllExport
RTIBool PRESTypePlugin_interpretedDeserializeWithAlloc(
        PRESTypePluginEndpointData endpointData,
        void **sample,
        RTIBool *dropSample,
        struct RTICdrStream *stream,
        RTIBool deserializeEncapsulation,
        RTIBool deserializeSample,
        void *endpointPluginQos);

extern PRESDllExport
RTIBool PRESTypePlugin_interpretedDeserializeKey(
        PRESTypePluginEndpointData endpointData,
        void *sample, 
        struct RTICdrStream *stream,
        RTIBool deserializeEncapsulation,
        RTIBool deserializeKey,
        void *endpointPluginQos);

extern PRESDllExport
RTIBool PRESTypePlugin_interpretedSkip(
        PRESTypePluginEndpointData endpointData,
        struct RTICdrStream *stream,   
        RTIBool skipEncapsulation,
        RTIBool skipSample, 
        void *endpointPluginQos);

extern PRESDllExport
unsigned int PRESTypePlugin_interpretedGetSerializedSampleMaxSize(
        PRESTypePluginEndpointData endpointData,
        RTIBool *overflow,
        RTIBool includeEncapsulation,
        RTIEncapsulationId encapsulationId,
        unsigned int current_alignment);

extern PRESDllExport
unsigned int PRESTypePlugin_interpretedGetSerializedKeyMaxSize(
        PRESTypePluginEndpointData endpointData,
        RTIBool *overflow,
        RTIBool includeEncapsulation,
        RTIEncapsulationId encapsulationId,
        unsigned int currentAlignment);

extern PRESDllExport
unsigned int PRESTypePlugin_interpretedGetSerializedSampleMinSize(
        PRESTypePluginEndpointData endpointData,
        RTIBool includeEncapsulation,
        RTIEncapsulationId encapsulationId,
        unsigned int current_alignment);

extern PRESDllExport
unsigned int PRESTypePlugin_interpretedGetSerializedSampleSize(
        PRESTypePluginEndpointData endpointData,
        RTIBool includeEncapsulation,
        RTIEncapsulationId encapsulationId,
        unsigned int currentAlignment,
        const void *sample);

extern PRESDllExport
RTIBool PRESTypePlugin_interpretedSerializedSampleToKey(
        PRESTypePluginEndpointData endpointData,
        void *sample,
        struct RTICdrStream *stream, 
        RTIBool deserializeEncapsulation,  
        RTIBool deserializeKey, 
        void *endpointPluginQos);

extern PRESDllExport
RTIBool PRESTypePlugin_interpretedSerializeKeyForKeyhash(
        PRESTypePluginEndpointData endpointData,
        const void *sample,
        struct RTICdrStream *stream,
        RTIEncapsulationId encapsulationId,
        void *endpointPluginQos);

extern PRESDllExport
RTIBool PRESTypePlugin_interpretedInstanceToKeyHash(
        PRESTypePluginEndpointData endpointData,
        struct MIGRtpsKeyHash *keyhash,
        const void *instance,
        RTIEncapsulationId encapsulationId);

extern PRESDllExport
unsigned int PRESTypePlugin_interpretedGetSerializedKeyMaxSizeForKeyhash(
        PRESTypePluginEndpointData endpointData,
        RTIBool *overflow,
        RTIEncapsulationId encapsulationId,
        unsigned int currentAlignment);


#ifdef __cplusplus
    }	/* extern "C" */
#endif
    
#include "pres/pres_typePlugin_impl.h"


#endif /* pres_typePlugin_h */
