/*

 (c) Copyright, Real-Time Innovations, 2017.
 All rights reserved.

 No duplications, whole or partial, manual or electronic, may be made
 without express written permission.  Any such copies, or
 revisions thereof, must display this notice unaltered.
 This code contains trade secrets of Real-Time Innovations, Inc.

===================================================================== */
#ifndef security_infrastructure_h
#define security_infrastructure_h

/*
 * SEC-1214: used for backward compatibility with respect to DH.
 * RTI Connext Pro below 6.1.0 uses legacy DH parameters.
 * RTI Connext Micro below 3.1.0 uses legacy DH parameters.
 */
#define RTI_SECURITY_VENDOR_ID_RTI_0 0x01
#define RTI_SECURITY_VENDOR_ID_RTI_1 0x01
#define RTI_SECURITY_VENDOR_ID_RTI_MICRO_0 0x01
#define RTI_SECURITY_VENDOR_ID_RTI_MICRO_1 0x0a
#define RTI_SECURITY_RTI_PRODUCT_VERSION_MAJOR_RFC5114 6
#define RTI_SECURITY_RTI_PRODUCT_VERSION_MINOR_RFC5114 1
#define RTI_SECURITY_RTI_MICRO_PRODUCT_VERSION_MAJOR_RFC5114 3
#define RTI_SECURITY_RTI_MICRO_PRODUCT_VERSION_MINOR_RFC5114 1

/*
 * SEC-850: used for backward interoperability with respect to precedence for
 * conflicting domain rules in the permissions document.
 * RTI Connext Pro below 6.1.1 uses legacy precedence.
 * RTI Connext Micro below 3.1.0 uses legacy precedence.
 */
#define RTI_SECURITY_RTI_PRODUCT_VERSION_MAJOR_FIRST_DOMAIN_RULE_PERMISSIONS_PRECEDENCE 6
#define RTI_SECURITY_RTI_PRODUCT_VERSION_MINOR_FIRST_DOMAIN_RULE_PERMISSIONS_PRECEDENCE 1
#define RTI_SECURITY_RTI_PRODUCT_VERSION_RELEASE_FIRST_DOMAIN_RULE_PERMISSIONS_PRECEDENCE 1
#define RTI_SECURITY_RTI_MICRO_PRODUCT_VERSION_MAJOR_FIRST_DOMAIN_RULE_PERMISSIONS_PRECEDENCE 3
#define RTI_SECURITY_RTI_MICRO_PRODUCT_VERSION_MINOR_FIRST_DOMAIN_RULE_PERMISSIONS_PRECEDENCE 1

#define RTI_SECURITY_RTI_PRODUCT_VERSION_MAJOR_LEGACY_KEST_ALGO 7
#define RTI_SECURITY_RTI_PRODUCT_VERSION_MINOR_LEGACY_KEST_ALGO 0
#define RTI_SECURITY_RTI_PRODUCT_VERSION_RELEASE_LEGACY_KEST_ALGO 0

#define RTI_SECURITY_RTI_PRODUCT_VERSION_MAJOR_LEGACY_DSIGN_ALGO 7
#define RTI_SECURITY_RTI_PRODUCT_VERSION_MINOR_LEGACY_DSIGN_ALGO 0
#define RTI_SECURITY_RTI_PRODUCT_VERSION_RELEASE_LEGACY_DSIGN_ALGO 0

#define RTI_SECURITY_FILES_POLL_INTERVAL_PROPERTY "files_poll_interval"
#define RTI_SECURITY_FILES_POLL_INTERVAL_DEFAULT ((DDS_UnsignedLong) 5) /* in s. */

#ifdef __cplusplus
    extern "C" {
#endif



#ifdef __cplusplus
    }   /* extern "C" */
#endif

#include "security/security_infrastructure_psm.h"

#endif /* security_infrastructure_h */