/* (c) Copyright 2003-2021, Real-Time Innovations, Inc. All rights reserved. */
/*
 * @(#)transport_tcp_log.h    generated by: makeheader    Sat Mar  9 09:51:46 2024
 *
 *		built from:	log.ifc
 */

#ifndef transport_tcp_log_h
#define transport_tcp_log_h


  #ifndef log_common_h
    #include "log/log_common.h"
  #endif
  #ifndef transport_tcp_dll_h
    #include "transport_tcp/transport_tcp_dll.h"
  #endif

#ifdef __cplusplus
    extern "C" {
#endif


/*i \ingroup NDDS_TransportTCPLogMessageClass
  \brief Transport-TCP socketutil identifier. For use in log message numbers.
  @see RTILogNumberBitmapClass
 */
  #define SUBMODULE_TRANSPORT_TCP_SOCKETUTIL       (0x0000)

/*i \ingroup NDDS_TransportTCPLogMessageClass
  \brief Transport-TCP OpenSSL identifier. For use in log message numbers.
  @see RTILogNumberBitmapClass
 */
  #define SUBMODULE_TRANSPORT_TCP_OPENSSL          (0x0001)

/*i \ingroup NDDS_TransportTCPLogMessageClass
  \brief Transport-TCP TCPv4 plugin identifier. For use in log message numbers.
  @see RTILogNumberBitmapClass
 */
  #define SUBMODULE_TRANSPORT_TCP_TCPV4            (0x0002)

/*i \ingroup NDDS_TransportTCPLogMessageClass
  \brief Transport-TCP TCPv4 plugin identifier. For use in log message numbers.
  @see RTILogNumberBitmapClass
 */
  #define SUBMODULE_TRANSPORT_TCP_CONTROL          (0x0002)



  #define NDDS_TRANSPORT_TCP_SUBMODULE_MASK_SOCKETUTIL (0x0001)


  #define NDDS_TRANSPORT_TCP_SUBMODULE_MASK_OPENSSL (0x0002)


  #define NDDS_TRANSPORT_TCP_SUBMODULE_MASK_TCPV4   (0x0004)


  #define NDDS_TRANSPORT_TCP_SUBMODULE_MASK_CONTROL (0x0008)


  #define NDDS_TRANSPORT_TCP_SUBMODULE_MASK_CONNECTION (0x0010)


  #define NDDS_TRANSPORT_TCP_SUBMODULE_MASK_ALL RTI_LOG_SUBMODULE_MASK_ALL

extern NDDS_Transport_TCP_DllExport
void NDDS_Transport_TCP_Log_set_dependency_instrumentation_mask(RTILogBitmap verbosity);


#ifdef __cplusplus
    }	/* extern "C" */
#endif

#endif /* transport_tcp_log_h */
